#!/usr/bin/perl  
$row = 0;

@buff = VIM::Buffers();
$b1 = $curwin->Buffer;
foreach $buff (@buff){
if($buff ne $b1) { $b2 = $buff};#Assuming that there are only 2 windows
}

sub help_maxaxa
{
$txt = "Alt{z}m: 
Alt{z}v:˳
Alt{z}k:
Alt{z}a:-ڵ:-- 
Alt{z}p:-ڵ:-- 
Alt{z}c:--
Alt{z}w:---
Alt{z}s:ע  
Alt{z}t:ݵ-  
Alt{z}q:quote-mArk-----
 
    mq ڦ";

@ans=split(/\n/,$txt);
$b2->Append($row,@ans);
$row = $row + 12;
}
1;

sub help
{
local($action) = @_;
$wrd = &get_word;
if($action eq "kAlAxi"){
&help_tam_vibh($wrd,"TAM",$lang);
}
elsif($action eq "aMwima"){
&dict_srch("aMwima",$wrd,$lang);
}
elsif($action eq "vibh"){
&help_tam_vibh($wrd,"VIBH",$lang);
}
elsif($action eq "praWama"){
&dict_srch("praWama",$wrd,$lang);
}
elsif($action eq "notation"){
&help_notation($wrd);
}
elsif($action eq "skt_dict"){
$wrd =~ s/^@//;
&srch($wrd,"approximate","Sanskrit");
}
elsif($action eq "t_e_dict"){
$wrd =~ s/^@//;
&srch($wrd,"telugu_english","");
}
}
1;

sub help_quote
{
$wrd=&get_word;
if($wrd =~ /`/)
{
if($wrd=~/#/){$wrd=~s/#//;}
if($wrd=~//.*/){$wrd=~s/\/.*//;}
use GDBM_File;
tie(%HELP_QUOTE,GDBM_File,"/home/bharathi/A-H/amba/VIM_INTFC/help/telugu/Word_Help/quote_help",GDBM_READER,0444);
@wrd =split(/[_{]/,$wrd);
foreach $wrd(@wrd)
{
if($wrd=~/\`/)
{
$wrd=~s/\n$//;
$ans=$HELP_QUOTE{$wrd};
if($ans eq "")
{
@ans = (" ܺ. ݹ    ܢ ");
$b2->Append($row,@ans);
$row = $row+$#ans;
}
else
{
open(TMP,"$ans");
@ans=<TMP>;
chop(@ans);
close(TMP);

$b2->Append($row,@ans);
$row = $row + $#ans;
$b2->Append($row,"----------------------------");
$row = $row+1;
}
}
}
}
else
{@ans = "  (cursor) back-quote(\`)    ϴ.";
$b2->Append($row,@ans);}
$row = $row + $#ans;
$b2->Append($row,"----------------------------");
$row = $row+1;
}
1;

sub help_notation{
local($in_wrd) = @_;
$in_wrd =~ s/#//g;
$in_wrd =~ s/@//g;
$in_wrd =~ s/`//g;
$in_wrd =~ s/\|//g;
if($in_wrd =~ /{\.?}/) { $b2->Append($row,"-Ը"); $row++;}
if($in_wrd =~ /{Z}/) { $b2->Append($row," ۳"); $row++;}
if($in_wrd =~ /^\^/) # help on carat
{
$b2->Append($row,"    ");$row++;
}
if($in_wrd =~ /\//) 
{
$b2->Append($row,"'\/'  :        ݵ        ׳  .   ע          ݳ .");
$row++;
}
if($in_wrd =~ /_/)
{
$b2->Append($row, "'_'      .");
$row++;
}
if($in_wrd =~ /\^$/)
{
$b2->Append($row," '^'    ۬         .");
$row++;
}
if($in_wrd=~ /\-/)
{
$b2->Append($row,"'-'         ޸ ۬  .");
$row++;
}
if($in_wrd =~/\*\_/)
{ 
$b2->Append($row,"'*_'  ڡ ھ       `*'   
                     ע  ˳ ѵ ."); 
$row = $row + 2;
}
if($in_wrd =~ /\_\*/)
{
$b2->Append($row,"'_* '       ע    .ڡ ھ `_*'
                   ע   ע 
                    ");
$row = $row + 3;
}
if($in_wrd =~ /\*\-/)
{
$b2->Append($row,"'*-'  :  ڡ `*'        .");
$row++;
}
if($in_wrd=~ /\~/)
{
$b2->Append($row,"'~'   : `~'   `ܢ  '  ޸  .");
$row++;
}
$b2->Append($row,"------------------------");
$row++;
}
1;

sub buffer2{
$b2 = $curwin->Buffer;
$b2->Append($row,"    mq ڦ");$row++;
$b2->Append($row,"------------------------");$row++;
}
1;
