#This file consists of subroutines that deals with jo-star construction

sub jo
{
    local($str1,$lft_str,$rt_str,$str2,$row,$pos,$str,$line_l,$line_r) ;
    ($row,$pos) = $curwin->Cursor();
    $str = $curwin->Buffer->Get($row);
    $str1 = substr($str,0,$pos);
    $str2 = substr($str,$pos);
    if($str1 =~ /[ \t]/) {
        $str1 =~ /^(.*)[ \t](.*)$/;
        $lft_str = $2;
        $line_l = $1.' ';
    }else {
        $lft_str = $str1;
    }
    if($str2 =~ /[ \t]/){
        $str2 =~ /^([^ \t]*)[ \t](.*)$/;
        $rt_str = $1;
        $line_r = ' '.$2;
    }else {
        $rt_str = $str2;
    }
    $sub_str = $lft_str.$rt_str;
    $sub_str =~ s/\*//g;
    $txt = $line_l.$sub_str.$line_r;
    $curwin->Buffer->Set($row, $txt); 
}
1;
sub jisane
{
    local($str1,$lft_str,$rt_str,$str2,$row,$pos,$str,$line_l,$line_r) ;
    ($row,$pos) = $curwin->Cursor();
    $str = $curwin->Buffer->Get($row);
    $str1 = substr($str,0,$pos);
    $str2 = substr($str,$pos);
    if($str1 =~ /[ \t]/) {
        $str1 =~ /^(.*)[ \t](.*)$/;
        $lft_str = $2;
        $line_l = $1.' ';
    }else {
        $lft_str = $str1;
    }
    if($str2 =~ /[ \t]/){
        $str2 =~ /^([^ \t]*)[ \t](.*)$/;
        $rt_str = $1;
        $line_r = ' '.$2;
    }else {
        $rt_str = $str2;
    }
    $sub_str = $lft_str.$rt_str;
    $sub_str =~ s/\*//g;
    $txt = $line_l.$sub_str.$line_r;
    $curwin->Buffer->Set($row, $txt); 
}
1;
sub jisame
{
    local($str1,$lft_str,$rt_str,$str2,$row,$pos,$str,$line_l,$line_r) ;
    ($row,$pos) = $curwin->Cursor();
    $str = $curwin->Buffer->Get($row);
    $str1 = substr($str,0,$pos);
    $str2 = substr($str,$pos);
    if($str1 =~ /[ \t]/) {
        $str1 =~ /^(.*)[ \t](.*)$/;
        $lft_str = $2;
        $line_l = $1.' ';
    }else {
        $lft_str = $str1;
    }
    if($str2 =~ /[ \t]/){
        $str2 =~ /^([^ \t]*)[ \t](.*)$/;
        $rt_str = $1;
        $line_r = ' '.$2;
    }else {
        $rt_str = $str2;
    }
    $sub_str = $lft_str.$rt_str;
    $sub_str =~ s/\*//g;
    $txt = $line_l.$sub_str.$line_r;
    $curwin->Buffer->Set($row, $txt); 
}
1;
sub jisapara
{
    local($str1,$lft_str,$rt_str,$str2,$row,$pos,$str,$line_l,$line_r) ;
    ($row,$pos) = $curwin->Cursor();
    $str = $curwin->Buffer->Get($row);
    $str1 = substr($str,0,$pos);
    $str2 = substr($str,$pos);
    if($str1 =~ /[ \t]/) {
        $str1 =~ /^(.*)[ \t](.*)$/;
        $lft_str = $2;
        $line_l = $1.' ';
    }else {
        $lft_str = $str1;
    }
    if($str2 =~ /[ \t]/){
        $str2 =~ /^([^ \t]*)[ \t](.*)$/;
        $rt_str = $1;
        $line_r = ' '.$2;
    }else {
        $rt_str = $str2;
    }
    $sub_str = $lft_str.$rt_str;
    $sub_str =~ s/\*//g;
    $txt = $line_l.$sub_str.$line_r;
    $curwin->Buffer->Set($row, $txt); 
}
1;
sub jisase
{
    local($str1,$lft_str,$rt_str,$str2,$row,$pos,$str,$line_l,$line_r) ;
    ($row,$pos) = $curwin->Cursor();
    $str = $curwin->Buffer->Get($row);
    $str1 = substr($str,0,$pos);
    $str2 = substr($str,$pos);
    if($str1 =~ /[ \t]/) {
        $str1 =~ /^(.*)[ \t](.*)$/;
        $lft_str = $2;
        $line_l = $1.' ';
    }else {
        $lft_str = $str1;
    }
    if($str2 =~ /[ \t]/){
        $str2 =~ /^([^ \t]*)[ \t](.*)$/;
        $rt_str = $1;
        $line_r = ' '.$2;
    }else {
        $rt_str = $str2;
    }
    $sub_str = $lft_str.$rt_str;
    $sub_str =~ s/\*//g;
    $txt = $line_l.$sub_str.$line_r;
    $curwin->Buffer->Set($row, $txt); 
}
1;
sub jisako
{
    local($str1,$lft_str,$rt_str,$str2,$row,$pos,$str,$line_l,$line_r) ;
    ($row,$pos) = $curwin->Cursor();
    $str = $curwin->Buffer->Get($row);
    $str1 = substr($str,0,$pos);
    $str2 = substr($str,$pos);
    if($str1 =~ /[ \t]/) {
        $str1 =~ /^(.*)[ \t](.*)$/;
        $lft_str = $2;
        $line_l = $1.' ';
    }else {
        $lft_str = $str1;
    }
    if($str2 =~ /[ \t]/){
        $str2 =~ /^([^ \t]*)[ \t](.*)$/;
        $rt_str = $1;
        $line_r = ' '.$2;
    }else {
        $rt_str = $str2;
    }
    $sub_str = $lft_str.$rt_str;
    $sub_str =~ s/\*/׳`/g;
    $txt = $line_l.$sub_str.$line_r;
    $curwin->Buffer->Set($row, $txt); 
}
1;

sub gnp_j0
{
local($row,$pos,$str,$line_l,$line_r);
($row,$pos) = $curwin->Cursor();
$str = $curwin->Buffer->Get($row);
$str1 = substr($str,0,$pos);
$str2 = substr($str,$pos);
if($str1 =~ /[ \t]/) {
    $str1 =~ /^(.*)[ \t](.*)$/;
    $lft_str = $2;
    $line_l = $1;
}else{
    $lft_str = $str1;
}
if($str2 =~ /[ \t]/){
    $str2 =~ /^([^ \t]*)[ \t](.*)$/;
    $rt_str = $1;
    $line_r = $2;
}else{
    $rt_str = $str2;
}
$sub_str = $lft_str.$rt_str;
if($line_r =~ /^\s*$/){ $line_r = '';}
if($line_r eq ''){
  $next_line = $curwin->Buffer->Get($row+3);  
  if($next_line =~ /[ \t]/){
      $next_line =~ /^[ \t]*([^ \t]*)[ \t]*(.*)$/;
      $next_str = $1;
      $next_line =~ s/$next_str//;
      $curwin->Buffer->Set($row+3, $next_line); 
  }
}elsif($line_r =~ /[ \t]/){
    $line_r =~ /^[ \t]*([^ \t]*)[ \t]*(.*)$/;
    $next_str = $1;
    $line_r = $2;
}else{
    $next_str = $str2;
}

if($sub_str =~ /\.$/){
    $sub_str =~ s/\*//;
}elsif($sub_str =~ s/\*_//){
    $sub_str = '  '.$next_str.' '.$sub_str;
}else{
    $substr = $sub_str.' '.$next_str;
}
#VIM::Msg("Sub:$sub_str");
$sub_str =~ s/_/ /g;
$txt = $line_l.' '.$sub_str.' '.$line_r;
$curwin->Buffer->Set($row, $txt); 
}
1;
sub gnp_jko
{
local($row,$pos,$str,$line_l,$line_r);
($row,$pos) = $curwin->Cursor();
$str = $curwin->Buffer->Get($row);
$str1 = substr($str,0,$pos);
$str2 = substr($str,$pos);
if($str1 =~ /[ \t]/) {
    $str1 =~ /^(.*)[ \t](.*)$/;
    $lft_str = $2;
    $line_l = $1;
}else{
    $lft_str = $str1;
}
if($str2 =~ /[ \t]/){
    $str2 =~ /^([^ \t]*)[ \t](.*)$/;
    $rt_str = $1;
    $line_r = $2;
}else{
    $rt_str = $str2;
}
$sub_str = $lft_str.$rt_str;
if($line_r =~ /^\s*$/){ $line_r = '';}
if($line_r eq ''){
  $next_line = $curwin->Buffer->Get($row+3);  
  if($next_line =~ /[ \t]/){
      $next_line =~ /^[ \t]*([^ \t]*)[ \t]*(.*)$/;
      $next_str = $1;
      $next_line =~ s/$next_str//;
      $curwin->Buffer->Set($row+3, $next_line); 
  }
}elsif($line_r =~ /[ \t]/){
    $line_r =~ /^[ \t]*([^ \t]*)[ \t]*(.*)$/;
    $next_str = $1;
    $line_r = $2;
}else{
    $next_str = $str2;
}
if($sub_str =~ /\.$/){
    $sub_str =~ s/\*/׳\'/;
}elsif($sub_str =~ s/\*_//){
    $sub_str = ' '.$next_str.'  '.$sub_str;
}else{
    $substr = $sub_str.' '.$next_str;
}
$sub_str =~ s/_/ /g;
$txt = $line_l.' '.$sub_str.' '.$line_r;
$curwin->Buffer->Set($row, $txt); 
}
1;
sub gnp_jne
{
local($row,$pos,$str,$line_l,$line_r);
($row,$pos) = $curwin->Cursor();
$str = $curwin->Buffer->Get($row);
$str1 = substr($str,0,$pos);
$str2 = substr($str,$pos);
if($str1 =~ /[ \t]/) {
    $str1 =~ /^(.*)[ \t](.*)$/;
    $lft_str = $2;
    $line_l = $1;
}else{
    $lft_str = $str1;
}
if($str2 =~ /[ \t]/){
    $str2 =~ /^([^ \t]*)[ \t](.*)$/;
    $rt_str = $1;
    $line_r = $2;
}else{
    $rt_str = $str2;
}
$sub_str = $lft_str.$rt_str;
if($line_r =~ /^\s*$/){ $line_r = '';}
if($line_r eq ''){
  $next_line = $curwin->Buffer->Get($row+3);  
  if($next_line =~ /[ \t]/){
      $next_line =~ /^[ \t]*([^ \t]*)[ \t]*(.*)$/;
      $next_str = $1;
      $next_line =~ s/$next_str//;
      $curwin->Buffer->Set($row+3, $next_line); 
  }
}elsif($line_r =~ /[ \t]/){
    $line_r =~ /^[ \t]*([^ \t]*)[ \t]*(.*)$/;
    $next_str = $1;
    $line_r = $2;
}else{
    $next_str = $str2;
}
if($sub_str =~ /\.$/){
    $sub_str =~ s/\*/\'/;
}elsif($sub_str =~ s/\*_//){
    $sub_str = ' '.$next_str.'  '.$sub_str;
}else{
    $substr = $sub_str.' '.$next_str;
}
$sub_str =~ s/_/ /g;
$txt = $line_l.' '.$sub_str.' '.$line_r;
$curwin->Buffer->Set($row, $txt); 
}
1;
sub gnp_jse
{
local($row,$pos,$str,$line_l,$line_r);
($row,$pos) = $curwin->Cursor();
$str = $curwin->Buffer->Get($row);
$str1 = substr($str,0,$pos);
$str2 = substr($str,$pos);
if($str1 =~ /[ \t]/) {
    $str1 =~ /^(.*)[ \t](.*)$/;
    $lft_str = $2;
    $line_l = $1;
}else{
    $lft_str = $str1;
}
if($str2 =~ /[ \t]/){
    $str2 =~ /^([^ \t]*)[ \t](.*)$/;
    $rt_str = $1;
    $line_r = $2;
}else{
    $rt_str = $str2;
}
$sub_str = $lft_str.$rt_str;
if($line_r =~ /^\s*$/){ $line_r = '';}
if($line_r eq ''){
  $next_line = $curwin->Buffer->Get($row+3);  
  if($next_line =~ /[ \t]/){
      $next_line =~ /^[ \t]*([^ \t]*)[ \t]*(.*)$/;
      $next_str = $1;
      $next_line =~ s/$next_str//;
      $curwin->Buffer->Set($row+3, $next_line); 
  }
}elsif($line_r =~ /[ \t]/){
    $line_r =~ /^[ \t]*([^ \t]*)[ \t]*(.*)$/;
    $next_str = $1;
    $line_r = $2;
}else{
    $next_str = $str2;
}
if($sub_str =~ /\.$/){
    $sub_str =~ s/\*/\'/;
    $sub_str =~ s/\*//;
}elsif($sub_str =~ s/\*_//){
    $sub_str = ' '.$next_str.'  '.$sub_str;
}else{
    $substr = $sub_str.' '.$next_str;
}
$sub_str =~ s/_/ /g;
$txt = $line_l.' '.$sub_str.' '.$line_r;
$curwin->Buffer->Set($row, $txt); 
}
1;
sub gnp_jme
{
local($row,$pos,$str,$line_l,$line_r);
($row,$pos) = $curwin->Cursor();
$str = $curwin->Buffer->Get($row);
$str1 = substr($str,0,$pos);
$str2 = substr($str,$pos);
if($str1 =~ /[ \t]/) {
    $str1 =~ /^(.*)[ \t](.*)$/;
    $lft_str = $2;
    $line_l = $1;
}else{
    $lft_str = $str1;
}
if($str2 =~ /[ \t]/){
    $str2 =~ /^([^ \t]*)[ \t](.*)$/;
    $rt_str = $1;
    $line_r = $2;
}else{
    $rt_str = $str2;
}
$sub_str = $lft_str.$rt_str;
if($line_r =~ /^\s*$/){ $line_r = '';}
if($line_r eq ''){
  $next_line = $curwin->Buffer->Get($row+3);  
  if($next_line =~ /[ \t]/){
      $next_line =~ /^[ \t]*([^ \t]*)[ \t]*(.*)$/;
      $next_str = $1;
      $next_line =~ s/$next_str//;
      $curwin->Buffer->Set($row+3, $next_line); 
  }
}elsif($line_r =~ /[ \t]/){
    $line_r =~ /^[ \t]*([^ \t]*)[ \t]*(.*)$/;
    $next_str = $1;
    $line_r = $2;
}else{
    $next_str = $str2;
}

if($sub_str =~ /\.$/){
    $sub_str =~ s/\*/\'/;
    $sub_str =~ s/\*//;
}elsif($sub_str =~ s/\*_//){
    $sub_str = ' '.$next_str.'  '.$sub_str;
}else{
    $substr = $sub_str.' '.$next_str;
}
$sub_str =~ s/_/ /g;
$txt = $line_l.' '.$sub_str.' '.$line_r;
$curwin->Buffer->Set($row, $txt); 
}
1;
sub gnp_jpara
{
local($row,$pos,$str,$line_l,$line_r);
($row,$pos) = $curwin->Cursor();
$str = $curwin->Buffer->Get($row);
$str1 = substr($str,0,$pos);
$str2 = substr($str,$pos);
if($str1 =~ /[ \t]/) {
    $str1 =~ /^(.*)[ \t](.*)$/;
    $lft_str = $2;
    $line_l = $1;
}else{
    $lft_str = $str1;
}
if($str2 =~ /[ \t]/){
    $str2 =~ /^([^ \t]*)[ \t](.*)$/;
    $rt_str = $1;
    $line_r = $2;
}else{
    $rt_str = $str2;
}
$sub_str = $lft_str.$rt_str;
if($line_r =~ /^\s*$/){ $line_r = '';}
if($line_r eq ''){
  $next_line = $curwin->Buffer->Get($row+3);  
  if($next_line =~ /[ \t]/){
      $next_line =~ /^[ \t]*([^ \t]*)[ \t]*(.*)$/;
      $next_str = $1;
      $next_line =~ s/$next_str//;
      $curwin->Buffer->Set($row+3, $next_line); 
  }
}elsif($line_r =~ /[ \t]/){
    $line_r =~ /^[ \t]*([^ \t]*)[ \t]*(.*)$/;
    $next_str = $1;
    $line_r = $2;
}else{
    $next_str = $str2;
}

if($sub_str =~ /\.$/){
    $sub_str =~ s/\*//;
    $sub_str =~ s/\*//;
}elsif($sub_str =~ s/\*_//){
    $sub_str = ' '.$next_str.'  '.$sub_str;
}else{
    $substr = $sub_str.' '.$next_str;
}
$sub_str =~ s/_/ /g;
$txt = $line_l.' '.$sub_str.' '.$line_r;
$curwin->Buffer->Set($row, $txt); 
}
1;
