@NOUN_PH = ();
@GNP_AGM = ();
$BORDER = '';
$LINE_OUTPUT = 3;

sub get_words_for_agm
{
  local($row, @pos, $line, @row_b, @pos_b, $word, @tmp);
  ($row, $pos) = $curwin->Cursor();
  ($row_b, $pos_b) = split(/,/, $BORDER);
  $BORDER = ''; #Reset BORDER it is very important
  $line = $curwin->Buffer->Get($row_b);
  if($row == $row_b){
    $line = substr($line, $pos_b, $pos);
    if($line =~ /(.*)[ \t]+[^ \t]*$/){
      $line = $1;
    }
    @tmp = split(/[ \t]+/, $line);
    foreach $word ( @tmp){
      @NOUN_PH = ($word.','.$row, @NOUN_PH) ;
    }
  }else{
    $line = substr($line, $pos_b);
    @tmp = split(/[ \t]+/, $line);
    foreach $word ( @tmp){
      @NOUN_PH = ($word.','.$row_b, @NOUN_PH) ;
    }
    $row_b += $LINE_OUTPUT;
    while($row > $row_b){
      $line = $curwin->Buffer->Get($row_b);
#  system("echo \" line: $line row:$row, row_b:$row_b\" >> see");
      @tmp = split(/[ \t]+/, $line);
      foreach $word ( @tmp){
        @NOUN_PH = ($word.','.$row_b, @NOUN_PH) ;
      }
      $row_b += $LINE_OUTPUT;
    }
    $line = substr($curwin->Buffer->Get($row), 0, $pos);
    if($line =~ /(.*)[ \t]*[^ \t]*$/){
      $line = $1;
    }
    @tmp = split(/[ \t]+/, $line);
    foreach $word ( @tmp){
      @NOUN_PH = ($word.','.$row_b, @NOUN_PH) ;
    }
  }
#  system("echo \" line: $line \" > see");
}
1;



sub border
{
  local($row, $pos);
  ($row, $pos) = $curwin->Cursor();
  $BORDER = $row.','.$pos;
#  system("echo \" BORDER: $BORDER \" > see");
  VIM::Msg("OK! border marked"); 
}
1;

sub noun_agm
{
  local($row, $pos, $word, $line, @tmp);
  ($row, $pos) = $curwin->Cursor();
  $line = $curwin->Buffer->Get($row);
  @tmp = &get_word($pos, $line);
  $word = $tmp[1];
  #$modified_word = &get_gender($word);
   $modified_word = $word;
  $GENDER = &get_gender_from_hindi_dict($word);
  $curwin->Buffer->Set($row, $tmp[0].$modified_word.$tmp[2]); 
  &perform_noun_phrase_agm($word);
}
1;

#perform_noun_phrase_agreement_
sub perform_noun_phrase_agm
{
  local($a, $word, $row, $temp, $adj, pos);
  $word = @_[0];
  if($BORDER ne ''){
#find_words for noun phrase agreement and place it in @NOUN_PH
    &get_words_for_agm;
  }
  $a = @NOUN_PH;
  if($a > 0)
  {
    #&get_gender($word);
    $GENDER = &get_gender_from_hindi_dict($word);
    foreach $temp (@NOUN_PH)
    {
       ($adj, $row) = split(/,/, $temp);
       $adj_m = &do_adj_grouping($adj);
       $line = $curwin->Buffer->Get($row);
       $line =~ s/$adj/$adj_m/g;
       $curwin->Buffer->Set($row, $line); 
    }
    @NOUN_PH = (); #Reset NOUN_PH this is very important
  }else{
      ($last_row, $last_pos) = $curwin->Cursor();
      $prev_word = &GetPrevWord;
#      system("echo \"$prev_word FLAG= $FLAG\" > see");
      while($FLAG == 1){
        ($adj, $row, $pos) = split(/,/, $prev_word);
#      system("echo \"\nWord:$adj, ROW:$row\" >> see");
        if($adj =~ /[\-_]$/){
          $adj_m = &do_adj_grouping($adj);
          $line = $curwin->Buffer->Get($row);
          $line =~ s/$adj/$adj_m/g;
#      system(" echo \"adj: $adj, row: $row, adj_m:$adj_m\n$line\" >see");
          $curwin->Buffer->Set($row, $line); 
          $curwin->Cursor($row, $pos); 
        }else{
          last;
        }
        $prev_word = &GetPrevWord;
#      system("echo \"$prev_word FLAG= $FLAG\" > see");
      }
      $curwin->Cursor($last_row, $last_pos+2); 
  }
  $NUMBER = '-'; #global variable resetted now.
}
1;
sub do_adj_grouping
{ 
  local ($word);
  $word = @_[0];
#  system("echo $NUMBER >see");
  if($NUMBER eq 'p'){
    $word =~ s///;
    $word =~ s///; 
    $word =~ s///;
    $word =~ s///; 
    $NUMBER = '-';
  }else{
    $word =~ s///;
    $word =~ s///;
  }

  #system("echo $GENDER ");
  VIM::Msg("$GENDER"); 
  if($GENDER eq 'f')
  { 
    $word =~ s/_$/_/;
    $word =~ s/\-$/-/;
    $word =~ s/$//;
  }else{
    $word =~ s/_$/_/;
    $word =~ s/\-$/-/;
    $word =~ s/$//;
  }
  #system("echo $word ");
  #VIM::Msg("$word"); 
  $word;
}
1;
