#!/usr/bin/perl
#%SYNM is associated with the disk file, where as %C_SYNM is 
#associative array(forms a circle) for the current word.

$| = 1;
use DB_File;
#$HOME = $ENV{'HOME'};
#$NAME = $ENV{'LOGNAME'};
dbmopen(%SYNM, "/home/bharathi/A-H/amba/VIM_INTFC/post-edit/thesauras", 0644);
dbmopen(%PERSONAL, "$HOME/thesauras", 0644);
dbmopen(%TEMP, "$HOME/temp_thes", 0644);
%C_SYNM = ();
$EDITCOUNT = 5;

sub Repl
{ my(@temp, $row, $pos, $line, $word);
  VIM::Msg("OK! Type synonym and press CRTL-TB");
  ($row, $pos) = $curwin->Cursor();
  $line = $curwin->Buffer->Get($row);
  @temp = &get_word($pos, $line);
  $R_WORD = $temp[1];
  $pos = length($temp[0]);
  $curwin->Buffer->Set($row, $temp[0].' '.$temp[2]); 
  $curwin->Cursor($row, $pos); 
#  sleep(1);
}
1;
sub store_in_thes
{
  my($choice, $key_val, $temp);
  $key_val = $PERSONAL{$R_WORD}.$SYNM{$R_WORD}.$TEMP{$R_WORD};
  $temp = $TEMP{$R_WORD};
  if($R_WORD eq $S_WORD){
    $MSG = "Can not replace $R_WORD by $S_WORD";
    $FLAG = 0;
  }elsif($key_val =~ /$S_WORD/){
    $MSG = "$S_WORD is already there";
    $FLAG = 0;
  }elsif($temp ne ''){
    $TEMP{$R_WORD} .= ','.$S_WORD;
    $MSG = "Replacement $R_WORD by $S_WORD stored in thesauras";
    $FLAG = 1;
    if($TEMP{'count'} eq ''){
      $TEMP{'count'} = 1;
    }else{
      $TEMP{'count'} +=  1;
    }
  }else{
    $TEMP{$R_WORD} = $S_WORD;
    $MSG = "Replacement $R_WORD by $S_WORD stored in thesauras";
    $FLAG = 1;
    if($TEMP{'count'} eq ''){
      $TEMP{'count'} = 1;
    }else{
      $TEMP{'count'} +=  1;
    }
  }
#  system("echo \"EDITCOUNT = $EDITCOUNT\" >see");
#  system("echo \"HOME = $HOME\" >>see");
#  system("echo \"NAME = $NAME\" >>see");
  if(($TEMP{'count'} % $EDITCOUNT) == 0){
    $choice = &one("Dear $NAME, Will you prefer conforming new entries in the Thesauras now?(Y/N)", 'Yes!', 'No!');
    if($choice =~ /^[yY]/){
      &conform;
    }else{
      $MSG = "ok I will ask later! or you can use 'te' command whenever you wish!";
    }
  }
}
1;

sub conform {
  my($no, $meaning, @tmp, $key, $value, $choice);
  foreach $key (keys %TEMP){
    if($key eq 'count'){ 
      next;
    }
    $value = $TEMP{$key};
    @tmp = split(/,/, $value);
    $no = @tmp;
#  print "$value, $no";
    if($no == 1){
      print "$key = $TEMP{$key} ";
      $choice = &one('Confirm? (Y/N)', 'Confirmed!', 'Deleted!');
      if($choice =~ /^[^nN]$/) {
        &make_permanent($key, $TEMP{$key});
      }
    }else{
      foreach $meaning (@tmp) {
        print "$key = $meaning ";
        $choice = &one('Confirm? (Y/N)', 'Confirmed!', 'Deleted!');
        if($choice =~ /^[^nN]$/) {
          &make_permanent($key, $meaning);
        }
      }
    } #foreach meaning
    delete $TEMP{$key};
  } #foreach word in TEMP
  $TEMP{'count'} = 0;
}
1;
sub make_permanent {
  my($key, $value) = @_;
  if($PERSONAL{$key} == '') {
    $PERSONAL{$key} = $value;
  }else{
    $PERSONAL .= ','.$value;
  }
}
1;
#**************
  
sub G_Subst
{ my(@temp, $row, $pos, $line, $word, $keyval);
#Message displayed earlier while replacement is performed
  ($row, $pos) = $curwin->Cursor();
  $line = $curwin->Buffer->Get($row);
  @temp = &get_word($pos, $line);
  $S_WORD = $temp[1];
  &store_in_thes;
#Add $S_WORD in the circular linked list of synonyms, i.e. C_SYNM
if(FLAG == 1){
  $C_SYNM{$S_WORD} = $C_SYNM{$R_WORD};
  $C_SYNM{$R_WORD} = $S_WORD;
}
#performing the replacement globally
  $POS = $pos;
  $ROW = $row;
  VI::Run($VI::ScreenId, "%s/$R_WORD/$S_WORD/gc");
  $curwin->Cursor($ROW, $POS); 
#  VIM::Msg("$SYNM{$R_WORD}");
}
1;
#sub resume_cursor
sub Rcursor
{
   $curwin->Cursor($ROW, $POS); 
}
1;
sub Subst
{ local($row, $pos, $line, $word, $keyval);
  ($row, $pos) = $curwin->Cursor();
  $line = $curwin->Buffer->Get($row);
  @temp = &get_word($pos, $line);
  $S_WORD = $temp[1];

  &store_in_thes;
#Add $S_WORD in the circular linked list of synonyms, i.e. C_SYNM
if(FLAG == 1){
  $C_SYNM{$S_WORD} = $C_SYNM{$R_WORD};
  $C_SYNM{$R_WORD} = $S_WORD;
}

#  VIM::Msg("$SYNM{$R_WORD}");
  VIM::Msg("$MSG");
}
1;
sub DoMenu
{ my(@temp, $row, $pos, $line, $word);
  ($row, $pos) = $curwin->Cursor();
  $ROW = $row;
  $POS = $pos;
#Check if the user is clicking on the same word at same position
#if no delete the current synonm associative array.
  $line = $curwin->Buffer->Get($row);
  @SEL_LINE = ($row, &get_word($pos, $line)); #line whose word will be modified
                                              #after menu selection.
  $R_WORD = $SEL_LINE[2];
  if($R_WORD =~ /^\s*$/) { return; }
  @MENU = &mk_synm_array;
  $ht = @MENU;
  if($ht == 1){
    VIM::Msg("Sorry! No synonym found!");
    return;
  }
  $bd = &calculate; #calculate the maximum width of elements in the global
                    # array @MENU as well as adjusts MENU
  &DrawMenu($row, $pos, $bd); # Menu is now a global variable, 
                          # Which it accesses directly
}
1;
sub Do
{ my(@temp, $row, $pos, $line, $word);
  ($row, $pos) = $curwin->Cursor();
#Check if the user is clicking on the same word at same position
#if no delete the current synonm associative array.
  if(($POS != $pos)||($ROW != $row)){
    %C_SYNM = ();
  }
  $POS = $pos;
  $ROW = $row;
  $line = $curwin->Buffer->Get($row);
  @temp = &get_word($pos, $line);
  $R_WORD = $temp[1];
  $word = $C_SYNM{$R_WORD};
  if($word eq ''){
    &mk_c_synm;
    $word = $C_SYNM{$R_WORD};
  }
  if($word ne ''){
    $curwin->Buffer->Set($row, $temp[0].$word.$temp[2]); 
    VIM::Msg('Replaced '.$temp[1].' by '.$word);
  }else{
    VIM::Msg("No synonym for $R_WORD found in the thesauras");
  }
}
1;
sub  mk_synm_array
{
  my($synms, @all_synms);
  $synms = $R_WORD.','.$TEMP{$R_WORD}.','.$PERSONAL{$R_WORD}.','.$SYNM{$R_WORD};
  @all_synms = split(/,+/, $synms);
  return @all_synms;
}
1;
sub  mk_c_synm
{
  my($synms, @all_synms, $r_word, $tmp);
  %C_SYNM = ();
  $synms = $TEMP{$R_WORD};
  if($synms eq ''){
    $synms .= $PERSONAL{$R_WORD};
  }else{
    $synms .= ','.$PERSONAL{$R_WORD};
  }
  if($synms eq ''){
    $synms .= $SYNM{$R_WORD};
  }else{
    $synms .= ','.$SYNM{$R_WORD};
  }
#  system("echo $synms >see");
  if($synms ne ''){
    @all_synms = split(/,/, $synms);
    $r_word = $R_WORD;
    foreach $tmp (@all_synms)
    {
      $C_SYNM{$r_word} = $tmp;
      $r_word = $tmp;
    }
    $C_SYNM{$r_word} = $R_WORD;
  }
}
1;
