WRD [A-Za-z][A-Za-z]*
SPACE [ \t\n]*
PLUS_MINUS [+-]
%%
{WRD}{SPACE}{PLUS_MINUS}{SPACE}{WRD}<ajFAwa>   {fun_tel_morph(yytext);}
{WRD}-{WRD}<ajFAwa>   {fun_tel_morph(yytext);}
{WRD}<ajFAwa>   {fun_tel_morph(yytext);}
%%
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#ifdef GNU
#include <gdbm.h>
#else
#include <ndbm.h>
#endif

#include "/home/bharathi/A-H/amba/anusAraka/com/morph/headers/struct1.h"

extern void *my_fatal();

fun_tel_morph(word)
char word[100];
{
char *tmp;
char word1[100],word2[100],non_word[100];
int i,j;
int DBM_FLAG = 1;

extern FILE *fp_pdgm;
#ifdef GNU
extern GDBM_FILE db_dict1;
#else
extern DBM *db_dict1;
#endif

#ifdef GNU
extern GDBM_FILE db_dict2;
#else
extern DBM *db_dict2;
#endif

#ifdef GNU
extern GDBM_FILE db_dict3;
#else
extern DBM *db_dict3;
#endif

#ifdef GNU
extern GDBM_FILE db_suff;
#else
extern DBM *db_suff;
#endif


extern void fun_morph();

struct ans_struct ans_ar[20];
word[strlen(word)-8] = '\0';
/*printf("word is : %s\n",word);*/
if(!index(word,'+') && !index(word,'-'))
{
/* printf("word is : %s\n",word); */
fun_morph(word,fp_pdgm,DBM_FLAG,db_dict1,db_suff,ans_ar);
if(ans_ar[0].offset == -2)
fun_morph(word,fp_pdgm,DBM_FLAG,db_dict2,db_suff,ans_ar);
if(ans_ar[0].offset == -2)
fun_morph(word,fp_pdgm,DBM_FLAG,db_dict3,db_suff,ans_ar);
if(ans_ar[0].offset == -2)
	printf("%s<ajFAwa>",word);
else printf("%s",word);
}
else if(index(word,'_'))
{
i=0;
while(isalpha(word[i])) { word1[i] = word[i];i++;}
j=i;
while(!isalpha(word[i])) { i++;}
while(word[i] != '\0') { word1[j] = word[i];i++;j++;}
word1[j] = '\0';
/*printf("word: %s\n",word1);*/
fun_morph(word1,fp_pdgm,DBM_FLAG,db_dict1,db_suff,ans_ar);
if(ans_ar[0].offset == -2)
fun_morph(word1,fp_pdgm,DBM_FLAG,db_dict2,db_suff,ans_ar);
if(ans_ar[0].offset == -2)
fun_morph(word1,fp_pdgm,DBM_FLAG,db_dict3,db_suff,ans_ar);
if(ans_ar[0].offset == -2)
	printf("%s<ajFAwa>",word1);
else printf("%s",word1);
}
else { 
/*printf("word is ++: %s\n",word);*/
i=0;
while(isalnum(word[i])) { word1[i] = word[i];i++;}
word1[i] = '\0';
j=0;
while(!isalnum(word[i])) {non_word[j] = word[i]; i++;j++;}
non_word[j] = '\0';
j=0;
while(word[i] != '\0') { word2[j] = word[i];i++;j++;}
word2[j] = '\0';
/*printf("%s%s%s\n",word1,non_word,word2);*/
fun_morph(word1,fp_pdgm,DBM_FLAG,db_dict1,db_suff,ans_ar);
if(ans_ar[0].offset == -2)
fun_morph(word1,fp_pdgm,DBM_FLAG,db_dict2,db_suff,ans_ar);
if(ans_ar[0].offset == -2)
fun_morph(word1,fp_pdgm,DBM_FLAG,db_dict3,db_suff,ans_ar);
if(ans_ar[0].offset == -2)
	printf("%s<ajFAwa>",word1);
else printf("%s",word1);
printf("%s",non_word);
fun_morph(word2,fp_pdgm,DBM_FLAG,db_dict1,db_suff,ans_ar);
if(ans_ar[0].offset == -2)
fun_morph(word2,fp_pdgm,DBM_FLAG,db_dict2,db_suff,ans_ar);
if(ans_ar[0].offset == -2)
fun_morph(word2,fp_pdgm,DBM_FLAG,db_dict3,db_suff,ans_ar);
if(ans_ar[0].offset == -2)
	printf("%s<ajFAwa>",word2);
else printf("%s",word2);
}
}

/* HEADERS  */

#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#ifdef GNU
#include <gdbm.h>
#else
#include <ndbm.h>
#endif

#include "/home/bharathi/A-H/amba/anusAraka/com/morph/headers/glbl.h"
#include "/home/bharathi/A-H/amba/anusAraka/com/morph/headers/defn.h"
#include "/home/bharathi/A-H/amba/anusAraka/com/morph/headers/struct.h"


/* Global Variables */
int DEBUG;
int DEBUG_NEW;
int FINDONCE;
int FOR_USER;
int DEFAULT_PARADIGM;
int ALWAYS_DEFAULT_PARADIGM;
int WORD_NUM;
int LINE_NUM_FLAG;
int UWORD_DICT;
int HORI_OUTPUT;
int YES_NO;
int KRIYAMULA;

FILE *fpt1,*fp_pdgm,*fp_prop_noun_dict,*fp_uword_dict;
#ifdef GNU
GDBM_FILE db_dict1,db_suff,db_uword,db_dict2,db_dict3;
#else
DBM *db_dict1,*db_suff,*db_uword,*db_dict2,*db_dict3;
#endif


int sizeof_prop_noun_lex;
struct lex_info prop_noun_lex_ar[1000];

extern void fgetword();
extern int fun_close();
extern void chk_uword_dict();
extern void resufun();
extern void resufun_hori();
extern void fun_morph();
extern char fun_read();
extern int snt_num();
extern int end_mark();
extern void print_snt_num();

main(argc,argv)
int argc;
char *argv[];
{
char morph[Morphsize];
char fpath[80],fname[80],fpath_dict1[80],fpath_dict2[80],fpath_dict3[80];
char upath[80],uname[80];
char line[100];

int i,swit1,c;
struct ans_struct ans_ar[20];
char uword_ans[200];

int sizeof_uword;
struct uword_dict uword_ar[10000];

swit1 = 1;
DEBUG = 0;
DEBUG_NEW = 0;
FINDONCE =0;
FOR_USER =0;
DEFAULT_PARADIGM =0;
ALWAYS_DEFAULT_PARADIGM =0;
WORD_NUM = 0;
LINE_NUM_FLAG = 0;
UWORD_DICT = 0;
YES_NO = 0;
KRIYAMULA = 0;

if (argc < 3 )
{
printf("Usage morph.out <pdgm_offset_info> <uword_dict_path> <dict_paths> [UFPADLY]\n");
exit(0);
}
if(argc > 4)
{
/** OPTION 'U' CREATES A FILE UWORD WHICH CAPTURES THE WORDS BEYOND
                    THE SCOPE OF THE MORPH   ****************/
        if (index(argv[6],'U') )
                swit1 = 0;
/* option 'F' is used for user friendly output. */
        if(index(argv[6],'F') )
                FOR_USER = 1;
/* Choose the default paradigm , if entry is not found in dict */
        if(index(argv[6],'P') )
                DEFAULT_PARADIGM = 1;
/* Always choose the default paradigm ,even though entry is found in dict */
        if(index(argv[6],'A') )
                ALWAYS_DEFAULT_PARADIGM = 1;
/* dbm files are being used. */
        if(index(argv[6],'D') )
                DBM_FLAG = 1;
/*  Line numbers are being provided by some other program*/
        if(index(argv[6],'L') )
                LINE_NUM_FLAG = 1;
        if(index(argv[6],'H') )
                HORI_OUTPUT = 1;
/* Check the Uword dict */
        if(index(argv[6],'W') )
                UWORD_DICT = 1;
/* set the debug flag */
        if(index(argv[6],'G') )
                DEBUG = 1;
/* answers yes if morph recognises, else answers no */
        if(index(argv[6],'Y') )
                YES_NO = 1;
/* analyses kriyAmula*/
        if(index(argv[6],'K') )
                KRIYAMULA = 1;


}
if(argc > 6)
    DEBUG_NEW = argv[6][0]-'0';
 if (swit1 == 0)
        fpt1 = fopen("uword","w");
/*uword contains words which are beyond the scope of the morph**/

strcpy(fpath,argv[1]);
strcpy(upath,argv[2]);
strcpy(fpath_dict1,argv[3]);
strcpy(fpath_dict2,argv[4]);
strcpy(fpath_dict3,argv[5]);

strcpy(fname,fpath);
strcat(fname,"/pdgm_offset_info");
if((fp_pdgm=fopen(fname,"r"))==NULL)
    {
    printf("Error in %s opening\n",fname);
    exit(0);
    }

strcpy(uname,upath);
strcat(uname,"/prop_noun_lex.dic");
if((fp_prop_noun_dict=fopen(uname,"r"))==NULL)
    {
    printf("Error in %s opening\n",uname);
    exit(0);
    }

i = 0;
fgetword(fp_prop_noun_dict,line,',');
while(strcmp(line,""))
{
strcpy(prop_noun_lex_ar[i].word,line);
fgetword(fp_prop_noun_dict,line,',');
strcpy(prop_noun_lex_ar[i].pdgm,line);
fgetword(fp_prop_noun_dict,line,',');
strcpy(prop_noun_lex_ar[i].cat,line);
fgetword(fp_prop_noun_dict,line,',');
i++;
}
sizeof_prop_noun_lex = i;

strcpy(uname,upath);
strcat(uname,"/uword.dic");
/*
printf("%s\n",uname);
*/
if((fp_uword_dict=fopen(uname,"r"))==NULL)
    {
    printf("Error in %s opening\n",uname);
    exit(0);
    }

i = 0;
fgetword(fp_uword_dict,line,' ');
while(strcmp(line,""))
{
strcpy(uword_ar[i].sl_word,line);
fgetword(fp_uword_dict,line,'\n');
strcpy(uword_ar[i].tl_word,line);
fgetword(fp_uword_dict,line,' ');
i++;
}
sizeof_uword = i;

if(DBM_FLAG)
{
strcpy(fname,fpath_dict1);
#ifdef GNU
db_dict1 = gdbm_open(fname,512,GDBM_READER,0666,my_fatal());
#else
db_dict1 = dbm_open(fname,O_RDONLY,0666);
#endif

strcpy(fname,fpath_dict2);
#ifdef GNU
db_dict2 = gdbm_open(fname,512,GDBM_READER,0666,my_fatal());
#else
db_dict2 = dbm_open(fname,O_RDONLY,0666);
#endif

strcpy(fname,fpath_dict3);
#ifdef GNU
db_dict3 = gdbm_open(fname,512,GDBM_READER,0666,my_fatal());
#else
db_dict3 = dbm_open(fname,O_RDONLY,0666);
#endif

strcpy(fname,fpath);
strcat(fname,"/suff");
#ifdef GNU
db_suff = gdbm_open(fname,512,GDBM_READER,0666,my_fatal());
#else
db_suff = dbm_open(fname,O_RDONLY,0666);
#endif

strcpy(uname,upath);
strcat(uname,"/uword");
#ifdef GNU
db_uword = gdbm_open(uname,512,GDBM_READER,0666,my_fatal());
#else
db_uword = dbm_open(uname,O_RDONLY,0666);
#endif

}
yylex();
}
