#!/usr/bin/perl
require "/home/bharathi/A-H/amba/anusAraka/com/lwg/look.pl";
if($ARGV[0] eq "h"){
printf("USAGE: perl noun_verb_lwg.pl lwg_dict <DBG>\n");
printf("lwg_dict : path of the lwg_dict file\n");
printf("DBG : optional parameter : value : 1/0\n");
exit(0);
}
$DEBUG = 0;
$DEBUG = $ARGV[1];
$FL = $ARGV[0];
if($DEBUG){
print $ARGV[0],"\n";
print $ARGV[1],"\n";
}
open(LWG,$FL) || die "$FL not found \n";
#
### MAIN FUNCTION STARTS
#
$/ = "\n\n"; # Read a paragraph
#For each paragraph, store the morph analysis  & the spaces in global
#arrays ana[$i],spc[$i]
while($in = <STDIN>)
{
if($DEBUG){ print $in,"\n";}
$in =~ s/_OUT/_OUT#/g;
$in =~ s/OUT_/#OUT_/g;
$in =~ s/_FRZ/_FRZ#/g;
$in =~ s/FRZ_/#FRZ_/g;
$in =~ s/_MO/_MO#/g;
$in =~ s/MO_/#MO_/g;
$i=0;
while($in =~ /([ 	_#^\n]*)([^#]*)/g) {
$spc[$i] = $1;
$ana[$i] = $2;
#$ana[$i] =~ s/_$//;
if($DEBUG){
print $i,"=",$spc[$i],$ana[$i],"\n";
}
$i++;
}
$cnt = $i;
if($DEBUG) { print "TOTAL WRDS IN PARAGRAPH = $cnt\n";}
$i = 0;
while($i < $cnt)
{
#if(($ana[$i] !~ /{[nPv] /) && ($ana[$i] !~ /Avy/)) {
##print "1",$spc[$i],$ana[$i],"\n";
#if($DEBUG){ print "\n";}
#print $spc[$i],$ana[$i];
#$i++;
#}
#else { 
#$ana[$i] =~ s/#//g;
$wrds_to_be_grpd = &chk_lwg_case($i) ;
if($DEBUG) {print "WRDS TO BE GRPD = $wrds_to_be_grpd \n";}
if($wrds_to_be_grpd == 2){
print $spc[$i],"LWG_",$ana[$i],"_LWG";
print $spc[$i+1],"LWG_",$ana[$i+1],"_LWG";
}
else{
print $spc[$i],$ana[$i];
}
$i = $i + $wrds_to_be_grpd;
if($DEBUG) { print "i incremented to $i \n";}
#}
}
#if($cnt > 0) {print "\n";}
#print "\n\n";
}
sub chk_lwg_case
{
local($k) = @_;
if($DEBUG){ print "ana[$k] = ",$ana[$k],"\n";}
if($DEBUG){ print "ana[$k+1] = ",$ana[$k+1],"\n";}
$noun = $ana[$k];
$verb = $ana[$k+1];

$noun =~ s/_OUT//g;
$noun =~ s/OUT_//g;
$noun =~ s/_FRZ//g;
$noun =~ s/FRZ_//g;
$noun =~ s/_MO//g;
$noun =~ s/MO_//g;
$noun =~ s///g;
@noun_ar = split(/\//,$noun);
$new_noun = "";
for($j=0;$j<=$#noun_ar;$j++) { 
if($noun_ar[$j] =~ / n /) { $new_noun = $new_noun ."/".$noun_ar[$j];}
}
$new_noun =~ s/^\///;

#if($DEBUG){ print "new_noun = ",$new_noun,"\n";}
$verb =~ s/_OUT//g;
$verb =~ s/OUT_//g;
$verb =~ s/_FRZ//g;
$verb =~ s/FRZ_//g;
$verb =~ s/_MO//g;
$verb =~ s/MO_//g;
$verb =~ s///g;
#if($DEBUG){ print "verb = ",$verb,"\n";}
@verb_ar = split(/\//,$verb);
$new_verb = "";
for($j=0;$j<=$#verb_ar;$j++) { 
if($verb_ar[$j] =~ / v /) { 
$new_verb = $new_verb ."/".$verb_ar[$j];
#if($DEBUG){ print "new_verb = ",$new_verb,"\n";}
}
}
$new_verb =~ s/^\///;
if($DEBUG){ print "NV",$new_noun,"1\n",$new_verb,"2\n";}

$key1 = $new_noun;
$key2 = $new_verb;

$key1 =~ s/^([a-zA-Z_\?]*){.*}/\1/;
$key2 =~ s/^([a-zA-Z_\?]*){.*}/\1/;

if($DEBUG){ print "noun = ",$key1,"\n";}
if($DEBUG){ print "verb = ",$key2,"\n";}
if($DEBUG){ print "ana[$k] = ",$ana[$k],"\n";}
if($DEBUG){ print "ana[$k+1] = ",$ana[$k+1],"\n";}
if($DEBUG){ print "new_noun = ",$new_noun,"\n";}
if($DEBUG){ print "new_verb = ",$new_verb,"\n";}
$key = $key1."-".$key2;
if($DEBUG){ print "KEY = ",$key,"\n";
print $new_noun,"1\n",$new_verb,"2\n";}
&look(*LWG,$key,1,0);
$fl_ln = <LWG>;
if($DEBUG){ print "fl_ln = ",$fl_ln,"END\n";}
chop($fl_ln);
chop($fl_ln); # To absorb 2 new lines
$incr = 1;
if($fl_ln eq $key) { 
$ana[$k] = $new_verb;
$ana[$k] =~ s/^([a-zA-Z_\?]*)/$key/;
$ana[$k] =~ s/\/.*//;
$ana[$k+1] = "---";
if($DEBUG){ print "ana[$k] = ",$ana[$k],"\n";}
if($DEBUG){ print "ana[$k+1] = ",$ana[$k+1],"\n";}
$incr = 2;
}
$incr;
}
1;
