%{
#include "exprsn.tab.h"
%}
WORD [-0-9a-zA-Z\`\*\^\%]
comment [=0-9a-zA-Z_\.\~\{\}\?,\*\`@|]
NUCLEAR_SENSE [=0-9a-zA-Z_\.\~\{\}\?,\*\`]
%%
{WORD}+/[^{]	{ strcpy(yylval.word,yytext);
                  if(DEBUG)printf("LEX: %s\n",yytext);
                  return fixed_exp;
                }
{WORD}+\{{comment}+\}	{ strcpy(yylval.word,yytext);
                  if(DEBUG)printf("LEX: %s\n",yytext);
                  return fixed_exp;
                }
{WORD}+\{{comment}+\}\-	{ strcpy(yylval.word,yytext);
                  if(DEBUG)printf("LEX: %s\n",yytext);
                  return fixed_exp;
                }
{WORD}+\[[<>]{NUCLEAR_SENSE}+\]/[^{]	{ strcpy(yylval.word,yytext);
                  if(DEBUG)printf("LEX: %s\n",yytext);
                  return fixed_exp;
                }
{WORD}+\[[<>]{NUCLEAR_SENSE}+\]\{{comment}+\}	{ strcpy(yylval.word,yytext);
                  if(DEBUG)printf("LEX: %s\n",yytext);
                  return fixed_exp;
                }
\{{comment}+\}	{ strcpy(yylval.word,yytext);
                  if(DEBUG)printf("LEX: %s\n",yytext);
                  return COMMENT;
                }
\n	return 0;
[_\[\]\/\+]	return yytext[0];
.	 { strcpy(yylval.word,yytext); return NON_EXP;}
%%
