%{
#include "exprsn.tab.h"
%}
%%
[a-zA-Z`\*\^]+/[^{]	{ strcpy(yylval.word,yytext);
                  if(DEBUG)printf("LEX: %s\n",yytext);
                  return WORD;
                }
[a-zA-Z`]+\{[0-9a-zA-Z_\.\~\/\{\}]*\}	{ strcpy(yylval.word,yytext);
                  if(DEBUG)printf("LEX: %s\n",yytext);
                  return WORD;
                }
\{[0-9a-zA-Z_\.\~\/\{\}]*\}	{ strcpy(yylval.word,yytext);
                  if(DEBUG)printf("LEX: %s\n",yytext);
                  return COMMENT;
                }
\n	return 0;
[_\[\]\/]	return yytext[0];
%%
