# This program converts a c program that uses ndbm to the one
# which allows both ndbm & gdbm files.
# While compileing the c program thus converted,
# one has to compile it with -DGNU option, to allow gdbm utilities.
# anu5 has only GDBM utility in perl5
while($in = <STDIN>)
{
if($in =~ /ndbm.h/)
{
$old = $in;
print "#ifdef GNU\n";
$in =~ s/<ndbm.h>/<gdbm.h>/;
print $in;
print "#else\n";
print $old;
print "#endif\n\n";
#print "\n\n#ifdef GNU\nvoid *my_fatal()\n{\n}\n#endif\n\n";
}
elsif($in =~ /DBM /)
{
$old = $in;
print "#ifdef GNU\n";
$in =~ s/DBM \*/GDBM_FILE /;
print $in;
print "#else\n";
print $old;
print "#endif\n\n";
}
elsif($in =~ /dbm_fetch/)
{
$old = $in;
print "#ifdef GNU\n";
$in =~ s/dbm_fetch/gdbm_fetch/;
print $in;
print "#else\n";
print $old;
print "#endif\n\n";
}
elsif($in =~ /dbm_open/)
{
$old = $in;
print "#ifdef GNU\n";
$in =~ s/dbm_open\((.*),(.*),(.*)\)/gdbm_open(\1,512,GDBM_READER,\3,my_fatal())/;
print $in;
print "#else\n";
print $old;
print "#endif\n\n";
}
else { print $in;}
}
