#!/usr/bin/perl
#Following is the map for notation
#Followed by a perl program for converting from our notation
#to this notation.
#
#a	A	i	I	u	U	e	E	ai
#									
#
#o	O	au	M	:	N       R
#       		                   
#
#
#k	kh	g	gh	ng
#				
#
#c	ch	j	jh	ny
#				
#
#T	Th	D	Dh	N
#				
#
#t	th	d	dh	n
#				
#
#p	ph	b	bh	m
#				
#
#y	r	l	v	sh	s	S	H	L
#								
#
#__________________________________________________
# Converts Roman alphabetic notation to more readable roman notat.
while (<>)  {
  s/z/N/g;
  s/H/:/g;
  s/h/H/g;

  s/K/kh/g;
  s/G/gh/g;
       #s/c/ch/g;  # Do not change --v
  s/C/ch/g; #             order
  s/J/jh/g;

  s/T/Th/g;  # Do not change --v
  s/t/T/g;   #             order

  s/D/Dh/g;  # Do not change --v
  s/d/D/g;   #             order

  s/w/t/g;
  s/W/th/g;
  s/x/d/g;
  s/X/dh/g;

  s/P/ph/g;
  s/B/bh/g;

  s/S/sh/g;
  s/R/S/g;
  s/q/R/g;
  s/O/au/g;
  s/E/ai/g;
  s/e([^V])/E\1/g;# if 'e' is not followed by 'V', change it to 'E'
  s/o([^V])/O\1/g;# if 'o' is not followed by 'V', change it to 'O'
  s/V//g; # this will convert 'eV' to 'e', and 'oV' to 'o'
  s/lY/L/g;
  s/f/ng/g;
  s/F/ny/g;
  print ;
}
