BEGIN
{
use POSIX qw(:termios_h);
my ($term,$oterm,$echo,$noecho,$fd_stdin);
$fd_stdin = fileno(STDIN);

$term = POSIX::Termios->new();
$term->getattr($fd_stdin);
$oterm = $term->getlflag();

$echo = ECHO|ECHOK|ICANON;
$noecho = $oterm & ~$echo;

sub cbreak {
$term->setlflag($noecho);
$term->setcc(VTIME,1);
$term->setattr($fd_stdin,TCSANOW);
}
sub cooked {
$term->setlflag($oterm);
$term->setcc(VTIME,0);
$term->setattr($fd_stdin,TCSANOW);
}
sub getone{
my $key = "";
cbreak();
sysread(STDIN,$key,1);
cooked();
#print "---->",$key;
return $key;
}
}
END { cooked() }
1;
