#!/usr/bin/perl
sub del_plus
{
  local($row,$pos,$str, $line_l, $line_r) ;
  ($row,$pos) = $curwin->Cursor();
  $line = $curwin->Buffer->Get($row);
  $str1 = substr($line,0,$pos);
  $str2 = substr($line,$pos);
  $str2 =~ s/\+/ /; # replace the first occurence of '_' bye space
  $curwin->Buffer->Set($row, $str1.$str2); 
  VIM::Msg("Deleted '+' !");
}
1;
sub del_
{
  local($row,$pos,$str, $line_l, $line_r) ;
  ($row,$pos) = $curwin->Cursor();
  $line = $curwin->Buffer->Get($row);
  $str1 = substr($line,0,$pos);
  $str2 = substr($line,$pos);
  $str2 =~ s/\_/ /; # replace the first occurence of '_' bye space
  $curwin->Buffer->Set($row, $str1.$str2); 
  VIM::Msg("Deleted '_' !");
}
1;

sub down
{
  local($row,$pos,$str, $line_l, $line_r) ;
  ($row,$pos) = $curwin->Cursor();

  $last_line = $curwin->Buffer->Get($row-1);
  @ans = &get_word($pos, $last_line);
  $dst_wrd = $ans[1];

  if($dst_wrd =~ /^[ \t]*$/){
    VIM::Msg("Please keep cursor at the right word!");
    return;
  }

  $curr_line = $curwin->Buffer->Get($row);
  @ans = &get_word($pos, $curr_line); 
  $line_l = $ans[0];
  $line_r = $ans[2];
  $trg_wrd = $ans[1];
  $curr_line = $line_l.$dst_wrd.$line_r; 
  $curwin->Buffer->Set($row, $curr_line); 
  if($trg_wrd =~ /^[ \t]*$/){
  }else{
    $i = $row + 1;
    $end = $curwin->Buffer->Count();
    while ($i < $end) {
      $_ = $curwin->Buffer->Get($i);
      if(/$dst_wrd/){
        $pos = index($_, $dst_wrd) + 1;
        $i++;
        $_ = $curwin->Buffer->Get($i);
        @ans = get_word($pos, $_);
        if($ans[1] =~ /$trg_wrd/){
            $_= $ans[0].$dst_wrd.$ans[2];
            $curwin->Buffer->Set($i, $_); 
        }
        $i++;
    }
    $i++;
    $curr_line = $_;
  }
}
  VIM::Msg("Replaced $trg_wrd, by $dst_wrd !");
}
1;

sub Del_lft
{
local($row,$pos,$str,$line_l,$line_r) ;
($row,$pos) = $curwin->Cursor();
$str = $curwin->Buffer->Get($row);
$str1 = substr($str,0,$pos);
$str2 = substr($str,$pos);

if($str1 =~ /[ \t]/) {
    $str1 =~ /^(.*)[ \t](.*)$/;
    $lft_str = $2;
    $line_l = $1.' ';
}else{
    $lft_str = $str1;
}
$pos -= length($lft_str);
#$lft_str =~ s/./ /g;
$txt = $line_l.$str2;
$curwin->Buffer->Set($row, $txt); 
$curwin->Cursor($row, $pos); 
VIM::Msg("Deleted  \'$lft_str\' !");
}
1;
sub Del_rgt
{
local($row,$pos,$str,$line_l,$line_r) ;
($row,$pos) = $curwin->Cursor();
$str = $curwin->Buffer->Get($row);
$str1 = substr($str,0,$pos);
$str2 = substr($str,$pos);

if($str2 =~ /[ \t]/){
    $str2 =~ /^([^ \t]*)[ \t](.*)$/;
    $rt_str = $1;
    $line_r = ' '.$2;
}else{
    $rt_str = $str2;
}
$txt = $str1.$line_r;
$curwin->Buffer->Set($row, $txt); 
VIM::Msg("Deleted  \'$rt_str\' !");
}
1;
sub gnp_fe
{
local($row,$pos,$str,$line_l,$line_r) ;
($row,$pos) = $curwin->Cursor();
$str = $curwin->Buffer->Get($row);
$str = substr($str, 0, $pos).'<>'.substr($str, $pos);
$str1 = substr($str,0,$pos);
$str2 = substr($str,$pos);
if($str1 =~ /[ \t]/) {
    $str1 =~ /^(.*)[ \t](.*)$/;
    $lft_str = $2;
    $line_l = $1.' ';
}else{
    $lft_str = $str1;
}
if($str2 =~ /[ \t]/){
    $str2 =~ /^([^ \t]*)[ \t](.*)$/;
    $rt_str = $1;
    $line_r = ' '.$2;
}else{
    $rt_str = $str2;
}
$sub_str = $lft_str.$rt_str;
if($sub_str =~ s/\{1_\.\}//){
    $sub_str =~ s///;
    $sub_str =~ s//ޡ/;
    $sub_str =~ s///;
    $sub_str =~ s///;
    $sub_str = &process($sub_str);
}
$txt = $line_l.$sub_str.$line_r;
$curwin->Buffer->Set($row, $txt); 
}
1;
sub gnp_male
{
local($row,$pos,$str,$line_l,$line_r) ;
($row,$pos) = $curwin->Cursor();
$str = $curwin->Buffer->Get($row);
$str = substr($str, 0, $pos).'<>'.substr($str, $pos);
$str1 = substr($str,0,$pos);
$str2 = substr($str,$pos);
if($str1 =~ /[ \t]/) {
    $str1 =~ /^(.*)[ \t](.*)$/;
    $lft_str = $2;
    $line_l = $1.' ';
}else{
    $lft_str = $str1;
}
if($str2 =~ /[ \t]/){
    $str2 =~ /^([^ \t]*)[ \t](.*)$/;
    $rt_str = $1;
    $line_r = ' '.$2;
}else{
    $rt_str = $str2;
}
$sub_str = $lft_str.$rt_str;
if($sub_str =~ s/\{1_\.\}//){
    $sub_str =~ s//ޡ/;
    $sub_str = &process($sub_str);
}else{
    $sub_str =~ s/\<\>//;
    $sub_str = $sub_str.'_';
}
$txt = $line_l.$sub_str.$line_r;
$curwin->Buffer->Set($row, $txt); 
}
1;
sub clean {
  my ($words, $i, $end);
  $i = 1;
  $end = $curwin->Buffer->Count();
  while ($i <= $end) {
    $_ = $curwin->Buffer->Get($i);
    if(s/[\#\+_\^\%\~]/ /g){
        s/([^ \t])`([ \t])/\1\2/g;
        s/`$//;
        s/{[^}]*}//g; # Added by amba to remove info in {}
        $curwin->Buffer->Set($i, $_); 
    }
    $i++;
  }
  VIM::Msg('Removed junk characters like +, ^, _, `, etc.');
}
1;
sub rt_shift
{
  local($row, $pos, $line, $word, $line_n, $word);
  ($row, $pos) = $curwin->Cursor();
  $line = $curwin->Buffer->Get($row);
  @temp = &get_word($pos, $line);
  $line_l = $temp[0];
  $word1   = $temp[1];
  $line_r = $temp[2];
  if($line_r =~ /^\s*/){
      $wh_sp = $&;
      $line_r = $';
  }
  if($line_r =~ /[^\s]+/){
      $word2 = $&;
      $line_r = $';
  }else{
      $line_n = $curwin->Buffer->Get($row+3);
      if($line_n =~ /[^ \t]*/)
      {
        $word2 = $&;
        $curwin->Buffer->Set($row+3,$word1.$'); 
        $word = $word1;
        $word1='';
      }
  }
  $curwin->Buffer->Set($row, $line_l.$word2.$wh_sp.$word1.$line_r); 
  if($word1 eq ''){
     $word1 = $word;
  }
  VIM::Msg("Interchanged $word1 and $word2!");
}
1;
sub plural
{
  local($row, $pos, $line, $word);
  ($row, $pos) = $curwin->Cursor();
  $line = $curwin->Buffer->Get($row);
  @temp = &get_word($pos, $line);
  $line_l = $temp[0];
  $word1   = $temp[1];
  $word2   = $temp[1];
  $line_r = $temp[2];
  #if($word1 =~ s/$/ڬ/){
  #}elsif($word1 =~ s/ڬ$//) {
  #}elsif($word1 =~ s/$//) {
  #}elsif($word1 =~ s/$//) {
  #}elsif($word1 =~ s/$/ڡ/) {
  #}elsif($word1 =~ s/ڡ$//) {
  #}else {
  #   $word1 =~ s/(.)$/\1/;
  #}
   $word1 =~ s/\{\.\}//;
   open(TMP,">/tmp/tmp0000");
   print TMP $word1;
   close(TMP);
   system("ir </tmp/tmp0000 > /tmp/tmp0001");
   open(TMP,"</tmp/tmp0001");
   $word1 = <TMP>;
   close(TMP);
   system("/home/bharathi/A-H/amba/new_anusAraka/gen/gen.out $word1 n m p NW 0 |ri > /tmp/tmp0001");
   open(TMP,"</tmp/tmp0001");
   $word3 = <TMP>;
   close(TMP);
  $curwin->Buffer->Set($row, $line_l.$word3.$line_r); 
  VIM::Msg("Replaced $word2 by $word3");
}
1;
sub help
{
   system("dialog --title HELP --textbox ~amba/VIM_INTFC/post-edit/help/help 20 80");
}
1;
sub easy
{
    local($str1,$lft_str,$rt_str,$str2,$row,$pos,$str,$line_l,$line_r) ;
    ($row,$pos) = $curwin->Cursor();
    $str = $curwin->Buffer->Get($row);
    $str = substr($str, 0, $pos).'<>'.substr($str, $pos);
    $str1 = substr($str,0,$pos);
    $str2 = substr($str,$pos);
    if($str1 =~ /[ \t]/) {
        $str1 =~ /^(.*)[ \t](.*)$/;
        $lft_str = $2;
        $line_l = $1.' ';
    }else {
        $lft_str = $str1;
    }
    if($str2 =~ /[ \t]/){
        $str2 =~ /^([^ \t]*)[ \t](.*)$/;
        $rt_str = $1;
        $line_r = ' '.$2;
    }else {
        $rt_str = $str2;
    }
    $sub_str = $lft_str.$rt_str;
#******
if($sub_str =~ s/<>//){
}elsif($sub_str =~ s/<>//){
}elsif($sub_str =~ s/<>//){
}elsif($sub_str =~ s/<>//){
}elsif($sub_str =~ s/<>//){
}elsif($sub_str =~ s/<>_\*/_/){
}elsif($sub_str =~ s/<>_/_/){
}elsif($sub_str =~ s/<>_/_/){
}elsif($sub_str =~ s/<>_/_/){
}elsif($sub_str =~ s/<>_/__/){
}elsif($sub_str =~ s/<>__/___/){
}elsif($sub_str =~ s/<>___/_/){
}elsif($sub_str =~ s/<>\`/_/){
}elsif($sub_str =~ s/<>//){
}elsif($sub_str =~ s/<>//){
}elsif($sub_str =~ s/<>//){
}elsif($sub_str =~ s/<>\`/_/){
}elsif($sub_str =~ s/<>//){
}elsif($sub_str =~ s/<>//){
}elsif($sub_str =~ s/<>//){
}elsif($sub_str =~ s/<>\*_/_/){
}elsif($sub_str =~ s/<>_/_/){
}elsif($sub_str =~ s/<>_/̻_/){
}elsif($sub_str =~ s/<>̻_/ѵ_/){
}elsif($sub_str =~ s/<>ѵ_/_/){
}elsif($sub_str =~ s/<>[ _]`/_/){
}elsif($sub_str =~ s/<>ݻ[ _]`/_/){
}elsif($sub_str =~ s/<>/ޡ/){
}elsif($sub_str =~ s/<>//){
}else{
    $sub_str =~ s/<>//;
}
#****** 
    $txt = $line_l.$sub_str.$line_r;
    $curwin->Buffer->Set($row, $txt); 
}
1;
