
sub long_word
{
#Assumption : words are seperated by either space or TABs
     my($pos,$str, $str1, $str2, $line_l, $line_r) = @_; 
     $str1 = substr($str,0,$pos);
     $str2 = substr($str,$pos);
     if($str1 =~ /[ \t]/) {
         $str1 =~ /(.*[" \t])(.*)$/;
         $lft_str = $2;
         $line_l = $1;
         if($lft_str =~ /(.*\+)(.*)$/){
           $lft_str = $2;
           $line_l = $line_l.$1;
         }
     }else{
         $lft_str = $str1;
         if($lft_str =~ /(.*\+)(.*)$/){
           $lft_str = $2;
           $line_l .= $1;
         }
     }
 
    if($str2 =~ /[ \t]/){
      $str2 =~ /^([^ \t]*)([ \t].*)$/;
      $rt_str = $1;
      $line_r = $2;
      if($rt_str =~ s/([\.\?\",])$//){
         $line_r = $1.$line_r;
      }
    } else {
      $rt_str = $str2;
    }
     $sub_str = $lft_str.$rt_str;
     @res = ($line_l, $sub_str, $line_r);
     @res;
}
1;
sub get_word
{
#places arguments value in $pos and $str only
    local($pos,$str, $str1, $str2, $line_l, $line_r) = @_; 
    $str1 = substr($str,0,$pos);
    $str2 = substr($str,$pos);
    if($str1 =~ /[ \t]/) {
        $str1 =~ /^(.*)[ \t](.*)$/;
        $lft_str = $2;
        $line_l = $1.' ';
    }else{
        $lft_str = $str1;
    }

    if($str2 =~ /[\.,;:\+\[ \t]/){
        $str2 =~ /^([^\.,;:\+\[ \t]*)([\.,;:\+\[ \t])(.*)$/;
        $rt_str = $1;
        $line_r = $2.$3;
        if($line_r =~ /^[^ }]*}/){
          $rt_str .= $&;
          $line_r = $';
        }
    }else{
        $rt_str = $str2;
    }
    $sub_str = $lft_str.$rt_str;
    @res = ($line_l, $sub_str, $line_r);
    @res;
}
1;

sub  get_sentence
{
  local($row, $call_no, $line);
  $row = $_[0];
  $call_no = $_[1];
  $line = $curwin->Buffer->Get($row);
  if($call_no == 0){
      if($line =~ /<s\d*>/){
          $line = $';
      }
      if($line =~ /<\.>/){
          $LINE = $`;
          $row;
      }else{
          $LINE = $line;
          $row += 3;
          $call_no++;
          get_sentence($row, $call_no);
      }
  }elsif($line =~ /<\.>/){
          $LINE = $LINE.$`;
          $row;
  }else{
      $LINE = $LINE.$line;
      $row += 3;
      $call_no++;
      get_sentence($row, $call_no);
  }
 $LINE;
}
1;
sub i2r
{
  $word = @_[0];
  system("echo $word>/tmp/.inword"); 
  system("ir </tmp/.inword  >/tmp/.outword"); 
  open(IN, "/tmp/.outword") || die "Cannot open /tmp/.outword"; 
  $_ = <IN>;
  chop();
  $_;
}
1;
sub r2i
{
  $word = @_[0];
  system("echo $word>/tmp/.inword"); 
  system("ri </tmp/.inword  >/tmp/.outword"); 
  open(IN, "/tmp/.outword") || die "Cannot open /tmp/.outword"; 
  $_ = <IN>;
  chop();
  $_;
}
1;
sub GetPrevWord
{ 
  local($row, $pos, $line, $prev_word);
  ($row,$pos) = $curwin->Cursor();
  $line = $curwin->Buffer->Get($row);
  $line = substr($line,0,$pos);
  if($line =~ /([^ \t]+)([ \t]+[^ \t]*$)/) {
    $pos -= length($1.$2);
    $FLAG = 1;
    $prev_word = $1.','.$row.','.$pos;
  }else{
     $prev_word = &RecurPreviousWord($row-3);
  }
#   if($FLAG == 1){
#    VIM::Msg("Prev_word : $prev_word !");
#  }else{
#    VIM::Msg("No previous word found!");
#  }
  $prev_word;
}
1;
sub RecurPreviousWord
{ local ($row, $pos, $prev_word, $line);
  $row = @_[0];
  #FLAG tells if the function was successful or not.
  $FLAG = 0;

  if($row > 0){
    $line = $curwin->Buffer->Get($row);
    $pos = length($line);
    if($line =~ /[ \t]+([^ \t\.,;]*)([\.,;]?[ \t]*)$/) {
      $prev_word = $1;
      $pos -= length($1.$2); 
      $FLAG = 1;
      $prev_word.','.$row.','.$pos;
    }else{
      &RecurPreviousWord($row-3);
    }
  }else{
      $FLAG = 0;
  }
}
1;

#waits for user to type one character and returns that character
#inefficient but it is the only way it works
sub one {
  system("perl /home/bharathi/A-H/amba/VIM_INTFC/post-edit/getone.pl \"@_[0]\" \"@_[1]\" \"@_[2]\"");
  open(CHO, '/tmp/.choice');
  $choice = <CHO>;
  close(CHO);
  $choice;
}
1;
sub expand
{ my ($word); 
  $word = @_[0];
  system("echo $word>/tmp/.inword"); 
  system("ir </tmp/.inword |/home/bharathi/A-H/amba/bison/exp |  ri >/tmp/.outword"); 
  open(IN, "/tmp/.outword") || die "Cannot open .outword"; 
  $_ = <IN>;
  chop();
  $_ =~ s/_0//;
  split(/\|/); 
}
1;
