#!/usr/bin/perl
sub substitute
{
    local($row,$pos,$str,$line_l,$line_r) ;
    ($row,$pos) = $curwin->Cursor();
    $str = $curwin->Buffer->Get($row);
    #$str = substr($str, 0, $pos).'<>'.substr($str, $pos);
    $str1 = substr($str,0,$pos);
    $str2 = substr($str,$pos);
    if($str1 =~ /[ \t]/) {
        $str1 =~ /^(.*)[ \t](.*)$/;
        $lft_str = $2;
        $line_l = $1.' ';
    } else {
        $lft_str = $str1;
    }
    if($str2 =~ /[ \t]/){
        $str2 =~ /^([^ \t]*)[ \t](.*)$/;
        $rt_str = $1;
        $line_r = ' '.$2;
    } else {
        $rt_str = $str2;
    }
    $sub_str = $lft_str.$rt_str;
    $sub_str =~ s/^(.*)<//;
    $sub_str =~ s/>//;
    $txt = $line_l.$sub_str.$line_r;
    $curwin->Buffer->Set($row, $txt); 
    VIM::Msg("Selected $sub_str");
}
1;
