#!/usr/bin/perl
# If mail has arrived, chk whether it is for
# Marking UW, or
# running trigger

open(TMP,$ARGV[0]);
# READ Mail header

$msg = 0;
$sbj_flag = 0;
while(($in = <TMP>) && ($sbj_flag != 1))
{
#print $in;
if($in =~ /^From /) { $from_add = $in;}
if($in =~ /^Return Path/) { $ret_path = $in;}
if($in =~ /^Received/) { $recd = $in;}
if($in =~ /^Date:/) { $date = $in;}
if($in =~ /^From:/) { $from1 = $in;}
if($in =~ /^Message-ID:/) { $msg_id = $in;}
if($in =~ /^To:/) { $to = $in;}
if($in =~ /^Subject:/) { $subj = $in; $sbj_flag = 1;}
}

#Get from address
$from_add =~ s/^From //;
$from_add =~ s/ .*//;
$from_add =~ s/\n$/ /;
#print "FFFF",$from_add;
#print "FFFF",$subj;

## Take the action in the subject
if($subj =~ /[mM][aA][rR][kK].*[uU][wW]/)
{
print STDERR " Marking UNKN wrds for the file sent by $from_add\n";
$subj = "Re: MARK_UW";
$action = "mo_d.sh < story ";
}
elsif($subj =~ /[hH][eE][lL][pP]/)
{
print STDERR " Sending help to $from_add\n";
$subj = "Re: Help";
$action = "";
}
elsif($subj =~ /[tT][eE][lL][uU][gG][uU].*[rR][eE][cC][oO][gG][nN][iI][sSzZ][eE][rR]/)
{
print STDERR " Marking UNKN wrds for the file sent by $from_add\n";
$subj = "Re: Telugu_Recogniser";
$action = "mo_7.sh < story ";
}
elsif($subj =~ /[tT][rR][iI][gG][gG][eE][rR][_\-][bB][hH][kK]/)
{
print STDERR " Running trigger on the file sent by $from_add\n";
$subj = "Re: TRIGGER_bhk";
$action = "trigger_bhk story ";
}
elsif($subj =~ /[kK][aA][nN][nN][aA][dD][aA]\-[hH][iI][nN][dD][iI]/)
{
print STDERR " Running kannada-hindi trigger on the file sent by $from_add\n";
$subj = "Re: KANNADA_HINDI";
$action = "anu_knd_7 < story ";
}
elsif($subj =~ /[kK][aA][nN][nN][aA][dD]/)
{
print STDERR " Running kannada-hindi trigger on the file sent by $from_add\n";
$subj = "Re: KANNADA_HINDI";
$action = "anu_knd_7 < story ";
}
elsif($subj =~ /[kK][aA][nN][nN][aA][dD][dD][aA]/)
{
print STDERR " Running kannada-hindi trigger on the file sent by $from_add\n";
$subj = "Re: KANNADA_HINDI";
$action = "anu_knd_7 < story ";
}
elsif($subj =~ /[tT][eE][lL][uU][gG][uU]\-[hH][iI][nN][dD][iI]/)
{
print STDERR " Running telugu-hindi trigger on the file sent by $from_add\n";
$subj = "Re: TELUGU_HINDI";
$action = "anu_tlg_7 < story ";
}
elsif($subj =~ /[tT][eE][lL][uU][gG][uU].*[aA][nN][uU][sS][aA][rR][aA][kK][aA]/)
{
print STDERR " Running telugu-hindi trigger on the file sent by $from_add\n";
$subj = "Re: TELUGU_ANUSARAK";
$action = "anu_tlg_7 < story ";
}
elsif($subj =~ /[tT][eE][lL][uU][gG][uU].*[aA][nN][uU][sS][aA][aA][rR][aA][kK]/)
{
print STDERR " Running telugu-hindi trigger on the file sent by $from_add\n";
$subj = "Re: TELUGU_ANUSARAK";
$action = "anu_tlg_7 < story ";
}
elsif($subj =~ /[tT][eE][lL][uU][gG][uU]/)
{
print STDERR " Running telugu-hindi trigger on the file sent by $from_add\n";
$subj = "Re: TELUGU_ANUSARAK";
$action = "anu_tlg_7 < story ";
}
elsif($subj =~ /[mM][aA][rR][aA][tT][hH][iI]\-[hH][iI][nN][dD][iI]/)
{
print STDERR " Running marathi-hindi trigger on the file sent by $from_add\n";
$subj = "Re:MARATHI_HINDI";
$action = "anu_mrt_7 < story ";
}
elsif($subj =~ /[mM][aA][rR][aA][tT][hH][iI].*/)
{
print STDERR " Running marathi-hindi trigger on the file sent by $from_add\n";
$subj = "Re:MARATHI ANUSARAKA";
$action = "anu_mrt_7 < story ";
}
elsif($subj =~ /[bB][aA][nN][gG][aA][lL][aA]/)
{
print STDERR " Running bangala-hindi trigger on the file sent by $from_add\n";
$subj = "Re:BANGALA ANUSARAKA";
$action = "anu_bng_7 < story ";
}
elsif($subj =~ /[bB][eE][nN][gG][aA][lL][iI]/)
{
print STDERR " Running bangala-hindi trigger on the file sent by $from_add\n";
$subj = "Re:BANGALA ANUSARAKA";
$action = "anu_bng_7 < story ";
}
elsif($subj =~ /[pP][uU][nN][jJ][aA][bB][iI]/)
{
print STDERR " Running punjabi-hindi trigger on the file sent by $from_add\n";
$subj = "Re:PUNJABI ANUSARAKA";
$action = "anu_pnj_7 < story ";
}

if($action ne ""){
#Put the mail msg in file "story"
print STDERR "STORY sent by the user \n";
open(STORY,">story");
$in = <TMP>;
if($in =~ /Status:/) { $Status = $in;} else { 
print STORY $in; 
print STDERR $in; 
}
while($in = <TMP>)
{
print STORY $in;
print STDERR $in; 
}
$from = $in;
close(STORY);

#Process the 'story'

system("$action > story.out");
system("rm msg");
system("cat /home/bharathi/A-H/amba/bin/anu_out.header story.out > OUT_n_header");
}
else{
system("cp /home/bharathi/A-H/amba/bin/anu.help OUT_n_header");
}

print STDERR "output sent to the user \n";
open(TMP,"<OUT_n_header");
$in = <TMP>;
while($in = <TMP>)
{
print STDERR $in; 
}
close(STORY);

#Send the output back to the sender
$mail_rpl = "mailx ".$from_add."-s \"".$subj."\" < OUT_n_header\n";
open(HEAD,">mail_header");
print HEAD $mail_hdr;
close(HEAD);
#print $mail_rpl,"\n";
system("$mail_rpl");
