%{
char ans[1000];
%}
%union {
char word[1000];
int num;
}
%token <word> fixed_exp
%token <word> NON_EXP
%token <word> COMMENT
%type <word> simple_fixed_exp
%type <word> simple_zero_choice
%type <word> simple_one_choice
%type <word> simple_choice
%type <word> complex_choice
%type <word> pre_statement
%type <word> statement
%start statement
%%
statement :	pre_statement { 
                   strcpy($$,$1);
		   printf("%s\n",$$);
		}
	  |	NON_EXP { 
                   strcpy($$,$1);
		   printf("%s\n",$$);
		}
	  |	pre_statement NON_EXP { 
                   strcpy($$,$1);
                   strcat($$,$2);
		   printf("%s\n",$$);
		}
	  |	pre_statement '+' pre_statement { 
                   strcpy($$,$1);
                   strcat($$,"+");
                   strcat($$,$3);
		   printf("%s\n",$$);
		}
          ;
pre_statement :	complex_choice { 
                   strcpy($$,$1);
		}
	  |	complex_choice '/' pre_statement { 
                   strcpy($$,$1);
                   strcat($$,"|");
                   strcat($$,$3);
		}
          ;
complex_choice : simple_choice	{
                   strcpy($$,$1);
                   if(DEBUG) printf("BISON RL 1: %s",$$);
			}
	       | simple_choice '_' complex_choice { 
                   expand($1,$3,$$);
                   if(DEBUG) printf("BISON RL 2: %s",$$);
			}
	       | complex_choice { 
                   strcpy($$,$1);
                   if(DEBUG) printf("BISON RL 3: %s",$$);
			}
	;
simple_choice : fixed_exp	{
                   strcpy($$,$1);
                   if(DEBUG) printf("BISON RL 6: %s",$$);
                }
	   |simple_zero_choice {
                   strcpy($$,$1);
                   if(DEBUG) printf("BISON RL 7: %s",$$);
                }
	   |simple_one_choice {
                   strcpy($$,$1);
                   if(DEBUG) printf("BISON RL 8: %s",$$);
                }
	;
simple_one_choice : fixed_exp '[' simple_fixed_exp ']'	{
                   strcpy($$,$1);
                   strcat($$,"|");
                   strcat($$,$3);
                   if(DEBUG) printf("BISON RL 9: %s",$$);
                }
		| fixed_exp '[' simple_fixed_exp ']' COMMENT	{
                   expand($1,$5,ans);
                   strcpy($$,ans);
                   strcat($$,"|");
                   expand($3,$5,ans);
                   strcat($$,ans);
                   if(DEBUG) printf("BISON RL 10: %s",$$);
                }
	;
simple_zero_choice : '[' simple_fixed_exp ']' COMMENT	{
                   strcpy($$,$4);
                   strcat($$,"|");
                   expand($2,$4,ans);
                   strcat($$,ans);
                   if(DEBUG) printf("BISON RL 11: %s",$$);
                }
		| '[' simple_fixed_exp ']' {
                   strcpy($$,"0|");
                   strcat($$,$2);
                   if(DEBUG) printf("BISON RL 12: %s",$$);
                }
	;
simple_fixed_exp : fixed_exp 	{
                   strcpy($$,$1);
                   if(DEBUG) printf("BISON RL 13: %s",$$);
                }
		| fixed_exp COMMENT	{
                   strcpy($$,$1);
                   strcat($$,$2);
                   if(DEBUG) printf("BISON RL 13.1: %s",$$);
                }
simple_fixed_exp : fixed_exp '/' simple_fixed_exp	{
                   strcpy($$,$1);
                   strcat($$,"|");
                   strcat($$,$3);
                   if(DEBUG) printf("BISON RL 14: %s",$$);
                }
	;
%%
