%union {
char word[100];
int num;
}
%token <word> WORD
%token <word> COMMENT
%type <word> expression
%type <word> statement
%left '/'
%left '_'
%start statement
%%
statement :	expression { 
		if(DEBUG) printf("\nBISON RL 1%s\n",$1);
		printf("%s\n",$1);
		}
	;
expression : expression '/' expression { 
                   strcpy($$,$1);
                   strcat($$,"OR"); 
                   strcat($$,$3);
                   if(DEBUG) printf("BISON RL 2: %s",$$);
                }
	|	expression '_' expression { 
		   if(DEBUG) printf("calling expand with %s %s\n",$1,$3);
		   expand($1,$3,$$);
                   if(DEBUG) printf("BISON RL 3: %s",$$);
                }
	|	 expression '[' expression ']'  { 
                   strcpy($$,$1);
                   strcat($$,"OR"); 
                   strcat($$,$3);
                   if(DEBUG) printf("BISON RL 4: %s",$$);
                }
	|	 expression '_' '[' '_' ']'  { 
                   strcpy($$,$1);
                   strcat($$,"OR"); 
                   strcat($$,$1);
                   strcat($$,"_");
                   if(DEBUG) printf("BISON RL 5: %s",$$);
                }
	|	 expression '_' { 
                   strcpy($$,$1);
                   strcat($$,"_");
                   if(DEBUG) printf("BISON RL 6: %s",$$);
                }
	|	 expression '_' '[' expression ']'  { 
                   strcat($4,"OR0");
		   expand($1,$4,$$);
                   if(DEBUG) printf("BISON RL 7: %s",$$);
                }
	|	WORD	{
                   strcpy($$,$1);
                   if(DEBUG) printf("BISON RL 8: %s",$$);
                }
	|	expression COMMENT	{
                   expand($1,$2,$$);
                   if(DEBUG) printf("BISON RL 9: %s",$$);
                }
	;
