$/ = "\n\n"; # Read a paragraph
#For each paragraph, store the morph analysis  & the spaces in an 
#array ana[$i],spc[$i]
while($in = <STDIN>)
{
$in =~ s/OUT/#/g;
$in =~ s/FRZ/#/g;
$i=0;
#while($in =~ /([ 	^\n]*)#_([^#]*)_#/g)
while($in =~ /([ 	_#^\n]*)([^#]*)/g)
{
$spc[$i] = $1;
$ana[$i] = $2;
$ana[$i] =~ s/_$//;
$i++;
}
$cnt = $i;
#print $cnt,"\n";
$i = 0;
while($i < $cnt)
{
if($ana[$i] !~ /{[nPv]/) {
#print "1",$spc[$i],$ana[$i],"\n";
print $spc[$i],$ana[$i],"_";
$i++;
}
else { 
$ana[$i] =~ s/#_//;
$ana[$i] =~ s/_#//;
if(!&chk_lwg_case($ana[$i])) { 
#print $spc[$i],"#_",$ana[$i],"_#"; 
#print "2",$spc[$i],$ana[$i],"\n"; 
print $spc[$i],$ana[$i]; 
$i++;
}
}
}
#print "\n\n";
}

sub chk_lwg_case
{
$lwg = 0;
# Examples :  ceVppi ceVppi
# algo : 
# ceVppi ceVppi -> ceVppu_i ceVppu_i
# -> ceVppu_0 ceVppi_i
if(($ana[$i] =~ /v=\*i\*=any/) && ($ana[$i+1] =~ /v=\*i\*=any/))
{
$ana[$i] =~ s/v=\*i\*=any/v=\*AjFArWa\*=any/;
#print "3",$spc[$i],"LWG_",$ana[$i],"_LWG_",$spc[$i+1],"LWG_",$ana[$i+1],"_LWG_";
print $spc[$i],"LWG_",$ana[$i],"_LWG_",$spc[$i+1],"LWG_",$ana[$i+1],"_LWG_";
$i=$i+2;
$lwg = 1;
}
#Example : ceVbuwU ceVbuwU
#algo :
#ceVbuwU ceVbuwU -> ceVbu_wU ceVbu_wU
#v_wU v_wU -> v_wU_lwg v_wU_lwg
#wU_lwg wU_lwg -> v_we v_we
elsif(($ana[$i] =~ /v=\*wU\*=any/) && ($ana[$i+1] =~ /v=\*wU\*=any/))
{
$ana[$i] =~ s/v=\*wU\*=any/v=\*wU_lwg\*=any/;
$ana[$i+1] =~ s/v=\*wU\*=any/v=\*wU_lwg\*=any/;
print $spc[$i],"LWG_",$ana[$i],"_LWG_",$spc[$i+1],"LWG_",$ana[$i+1],"_LWG_";
$i=$i+2;
$lwg = 1;
}
#Example : ceVppagA ceVppagA
#algo :
#ceVppagA ceVppagA -> ceVppu_a_gA ceVppu_a_gA
#v_a_gA v_a_gA -> v_a_gA_a_gA_lwg
#a_gA_a_gA_lwg -> v_we_rahane_para
elsif(($ana[$i] =~ /v=\*a_gA\*=any/) && ($ana[$i+1] =~ /v=\*a_gA\*=any/))
{
$ana[$i] =~ s/v=\*a_gA\*=any/v=\*a_gA_a_gA_lwg\*=any/;
print $spc[$i],"LWG_",$ana[$i],"_LWG_",$spc[$i+1],"LWG_---_LWG_";
$i=$i+2;
$lwg = 1;
}
#Example : ceVyyAlane ceSAdu
#algo :
#ceVyyAlane ceSAdu -> ceVyyi_Ali_ane ceVyyi_A
#v_Ali_ane v_A -> v_Ali_ane_A_lwg
#Ali_ane_A_lwg -> jAna_bUJa_kara_hI_v_yA
elsif(($ana[$i] =~ /v=\*Ali_ane\*=any/) && ($ana[$i+1] =~ /v=\*A\*=/))
{
$ana[$i+1] =~ s/v=\*A\*=/v=\*Ali_ane_A_lwg\*=/;
print $spc[$i],"LWG_",$ana[$i+1],"_LWG_",$spc[$i+1],"LWG_---_LWG_";
$i=$i+2;
$lwg = 1;
}
#Example : ceVyyAlani ceSAdu
#algo :
#ceVyyAlani ceSAdu -> ceVyyi_Ali_ani ceVyyi_A
#v_Ali_ani v_A -> v_Ali_ani_A_lwg
#Ali_ani_A_lwg -> jAna_bUJa_kara_v_yA
elsif(($ana[$i] =~ /v=\*Ali_ani\*=any/) && ($ana[$i+1] =~ /v=\*A\*=/))
{
$ana[$i+1] =~ s/v=\*A\*=/v=\*Ali_ani_A_lwg\*=/;
print $spc[$i],"LWG_",$ana[$i+1],"_LWG_",$spc[$i+1],"LWG_---_LWG_";
$i=$i+2;
$lwg = 1;
}
#Example : uMte uMdavaccu
#algo :
#uMte uMdavaccu -> uMdu_we uMdu_a_vaccu
#v_we v_a_vaccu -> v_we_a_vaccu_lwg
#we_a_vaccu_lwg -> ??
elsif(($ana[$i] =~ /v=\*we\*=any/) && ($ana[$i+1] =~ /v=\*a_vaccu\*=any/))
{
$ana[$i] =~ s/v=\*we\*=any/v=\*we_a_vaccu_lwg\*=any/;
print $spc[$i],"LWG_",$ana[$i],"_LWG_",$spc[$i+1],"LWG_---_LWG_";
$i=$i+2;
$lwg = 1;
}
#Example : uMte uMtAdu
#algo :
#uMte uMtAdu -> uMdu_we uMdu_wA
#v_we v_wA -> v_we_wA_lwg
#we_wA_lwg -> ??
elsif(($ana[$i] =~ /v=\*we\*=any/) && ($ana[$i+1] =~ /v=\*wA\*=/))
{
$ana[$i+1] =~ s/v=\*wA\*=/v=\*we_wA_lwg\*=/;
print $spc[$i],"LWG_",$ana[$i+1],"_LWG_",$spc[$i+1],"LWG_---_LWG_";
$i=$i+2;
$lwg = 1;
}
#Example : uMte unnAdu
#algo :
#uMte unnAdu -> uMdu_we uMdu_A
#v_we v_A -> v_we_A_lwg
#we_A_lwg -> ??
elsif(($ana[$i] =~ /v=\*we\*=any/) && ($ana[$i+1] =~ /v=\*A\*=/))
{
$ana[$i+1] =~ s/v=\*A\*=/v=\*we_A_lwg\*=/;
print $spc[$i],"LWG_",$ana[$i+1],"_LWG_",$spc[$i+1],"LWG_---_LWG_";
$i=$i+2;
$lwg = 1;
}
#Example : cUsI cUdaka
#algo :
#cUsI cUdaka -> cUdu_i_V cUdu_aka
#v_i_V v_aka -> v_i_V_aka_lwg
#i_V_aka_lwg -> nahIM+yA~EsA
elsif(($ana[$i] =~ /v=\*i_V\*=any/) && ($ana[$i+1] =~ /v=\*aka\*=any/))
{
$ana[$i+1] =~ s/v=\*aka\*=/v=\*i_V_aka_lwg\*=/;
print $spc[$i],"LWG_",$ana[$i+1],"_LWG_",$spc[$i+1],"LWG_---_LWG_";
$i=$i+2;
$lwg = 1;
}
#Example : cesinA ceswAdu
#algo :
#cesinA ceswAdu -> ceVyyu_inA ceVyyu_wA
#v_inA v_wA -> v_inA_wA_lwg
#inA_wA_lwg -> 0~BI_sakawA_hE
elsif(($ana[$i] =~ /v=\*inA\*=any/) && ($ana[$i+1] =~ /v=\*wA\*=/))
{
$ana[$i+1] =~ s/v=\*wA\*=/v=\*inA_wA_lwg\*=/;
print $spc[$i],"LWG_",$ana[$i+1],"_LWG_",$spc[$i+1],"LWG_---_LWG_";
$i=$i+2;
$lwg = 1;
}
#Example : veVlYlI veVlYlagAne
#algo :
#veVlYlI veVlYlagAne -> veVlYlu_i_V veVlYlu_a_gAne
#v_i_V v_a_gAne -> v_i_V_a_gAne_lwg
#i_V_a_gAne_lwg -> nA~ke_wuraMwa_bAxa
elsif(($ana[$i] =~ /v=\*i_V\*=any/) && ($ana[$i+1] =~ /v=\*a_gAne\*=/))
{
$ana[$i] =~ s/v=\*i_V\*=/v=\*i_V_a_gAne_lwg\*=/;
print $spc[$i],"LWG_",$ana[$i],"_LWG_",$spc[$i+1],"LWG_---_LWG_";
$i=$i+2;
$lwg = 1;
}
#Example : veVlYlanannA veVlYlawAdu
#algo :
#veVlYlanannA veVlYlawAdu -> veVlYlu_a_EnA veVlYlu_wA
#v_a_EnA v_wA -> v_a_EnA_wA_lwg
#a_EnA_wA_lwg -> 
elsif(($ana[$i] =~ /v=\*a_EnA\*=any/) && ($ana[$i+1] =~ /v=\*wA\*=/))
{
$ana[$i+1] =~ s/v=\*wA\*=/v=\*a_EnA_wA_lwg\*=/;
print $spc[$i],"LWG_",$ana[$i+1],"_LWG_",$spc[$i+1],"LWG_---_LWG_";
$i=$i+2;
$lwg = 1;
}
#Example : veVlYlanannA veVlYladu
#algo :
#veVlYlanannA veVlYladu -> veVlYlu_a_EnA veVlYlu_a
#v_a_EnA v_a -> v_a_EnA_a_lwg
#a_EnA_a_lwg ->
elsif(($ana[$i] =~ /v=\*a_EnA\*=any/) && ($ana[$i+1] =~ /v=\*a\*=/))
{
$ana[$i+1] =~ s/v=\*a\*=/v=\*a_EnA_a_lwg\*=/;
print $spc[$i],"LWG_",$ana[$i+1],"_LWG_",$spc[$i+1],"LWG_---_LWG_";
$i=$i+2;
$lwg = 1;
}
#Example : ceVppanEnA ceVppakapoyAdu
#algo :
#ceVppanEnA ceVppakapoyAdu -> ceVppu_a_EnA ceVppu_aka_po_A_lwg
#v_a_EnA v_aka_po_A -> v_a_EnA_aka_po_A_lwg
#a_EnA_aka_po_A_lwg ->
elsif(($ana[$i] =~ /v=\*a_EnA\*=any/) && ($ana[$i+1] =~ /v=\*aka_po_A\*=/))
{
$ana[$i+1] =~ s/v=\*aka_po_A\*=/v=\*a_EnA_aka_po_A_lwg\*=/;
print $spc[$i],"LWG_",$ana[$i+1],"_LWG_",$spc[$i+1],"LWG_---_LWG_";
$i=$i+2;
$lwg = 1;
}
#Example : veVlYlanU veVlYlAdu
#algo :
#veVlYlanU veVlYlAdu -> veVlYlu_a_V veVlYlu_A
#v_a_V v_A -> v_a_V_A_lwg
#a_V_A_lwg -> yA~BI_WA
elsif(($ana[$i] =~ /v=\*a_V\*=any/) && ($ana[$i+1] =~ /v=\*A\*=/))
{
$ana[$i+1] =~ s/v=\*A\*=/v=\*a_V_A_lwg\*=/;
print $spc[$i],"LWG_",$ana[$i+1],"_LWG_",$spc[$i+1],"LWG_---_LWG_";
$i=$i+2;
$lwg = 1;
}
#Example : veVlYlanU veVlYladu
#algo :
#veVlYlanU veVlYladu -> veVlYlu_a_V veVlYlu_a
#v_a_V v_a -> v_a_V_a_lwg
#a_V_a_lwg -> 
elsif(($ana[$i] =~ /v=\*a_V\*=any/) && ($ana[$i+1] =~ /v=\*a\*=/))
{
$ana[$i+1] =~ s/v=\*A\*=/v=\*a_V_A_lwg\*=/;
print $spc[$i],"LWG_",$ana[$i+1],"_LWG_",$spc[$i+1],"LWG_---_LWG_";
$i=$i+2;
$lwg = 1;
}
#Example : veVlYlane veVlYlAdu
#algo :
#veVlYlane veVlYlAdu -> veVlYlu_a_e veVlYlu_A
#v_a_e v_A -> v_a_e_A_lwg
#a_e_A_lwg -> 
elsif(($ana[$i] =~ /v=\*an_e\*=any/) && ($ana[$i+1] =~ /v=\*A\*=/))
{
$ana[$i+1] =~ s/v=\*a\*=/v=\*an_e_A_lwg\*=/;
print $spc[$i],"LWG_",$ana[$i+1],"_LWG_",$spc[$i+1],"LWG_---_LWG_";
$i=$i+2;
$lwg = 1;
}
#Example : veVlYlane veVlYladu
#algo :
#veVlYlane veVlYladu -> veVlYlu_a_e veVlYlu_a
#v_a_e v_a -> v_a_e_a_lwg
#a_e_a_lwg -> 
elsif(($ana[$i] =~ /v=\*an_e\*=any/) && ($ana[$i+1] =~ /v=\*a\*=/))
{
$ana[$i+1] =~ s/v=\*a\*=/v=\*an_e_a_lwg\*=/;
print $spc[$i],"LWG_",$ana[$i+1],"_LWG_",$spc[$i+1],"LWG_---_LWG_";
$i=$i+2;
$lwg = 1;
}
#Example : veVlYlanU lexu/lemu/lenu/leru/ledu
#algo :
#veVlYlanU lexu/lemu/lenu/leru/ledu -> veVlYlu_a_V gala_a
#v_a_V gala_a -> v_a_V_gala_a_lwg
#a_V_gala_a_lwg -> yA~BI_nahIM
elsif(($ana[$i] =~ /v=\*a_V\*=any/) && ($ana[$i+1] =~ /gala{v=\*a\*=/))
{
$ana[$i] =~ s/v=\*a_V\*=/v=\*a_V_a_gala_lwg\*=/;
print $spc[$i],"LWG_",$ana[$i],"_LWG_",$spc[$i+1],"LWG_---_LWG_";
$i=$i+2;
$lwg = 1;
}
#Example : veVlYlane lexu/lemu/lenu/leru/ledu
#algo :
#veVlYlane lexu/lemu/lenu/leru/ledu -> veVlYlu_a_V gala_a
#v_a_e gala_a -> v_a_e_gala_a_lwg
#a_e_gala_a_lwg -> yA~hI_nahIM
elsif(($ana[$i] =~ /v=\*an_e\*=any/) && ($ana[$i+1] =~ /gala{v=\*a\*=/))
{
$ana[$i] =~ s/v=\*an_e\*=/v=\*a_e_a_gala_lwg\*=/;
print $spc[$i],"LWG_",$ana[$i],"_LWG_",$spc[$i+1],"LWG_---_LWG_";
$i=$i+2;
$lwg = 1;
}
#Dirty solution:
#Example : veVlYlane nahIM
#algo :
#veVlYlane nahIM -> veVlYlu_a_V nahIM
#v_a_e gala_a -> v_a_e_gala_a_lwg
#a_e_gala_a_lwg -> yA~hI_nahIM
elsif(($ana[$i] =~ /v=\*an_e\*=any/) && ($ana[$i+1] =~ /nahIM/))
{
$ana[$i] =~ s/v \*an_e\* /v \*a_e_a_gala_lwg\* /;
print $spc[$i],"LWG_",$ana[$i],"_LWG_",$spc[$i+1],"LWG_---_LWG_";
$i=$i+2;
$lwg = 1;
}
$lwg;
}
1;
