#This program picks up a random sample of given size from a given file ( containing sentences)
#Usage : perl pick_random.pl <sample_size>

require "/usr3/epc002/my_lib/perl/look_num.pl";
require "/home/bharathi/A-H/amba/tools/src/random/parameters.pl";

open(FREQ,$freq_tab) || die "print $freq_tab can not be opened for reading\n";
open(IN,$freq_1) || die "print $freq_1 can not be opened for reading\n";
# f0s is a file with freq = 1
dbmopen(%WRDS,$word_dbm,0666) || die "Can't open $word_dbm for reading\n";

$sample_size = $ARGV[0];

srand; # sets the seed for rand opertor. Does srand(time).
for($i = 0;$i<$sample_size;$i++)
{
$random = int(rand($size_of_file));
if($random > $limit_for_freq_1) 
{ # select from words with freq = 1
$seek_ptr = (int($random)-$limit_for_freq_1)*$line_width;
$success=seek(IN,$seek_ptr,0);
if(!$success) { print "seek unsuccessful\n";}
else
{
$word = <IN>;
print $seek_ptr," ",$word;
}
}
else
{
# get the position of the word in WRDS file
$ptr = &look_num(FREQ,$random,0,0);
seek(FREQ,$ptr,0);
$ln = <FREQ>;
$ln =~ /^(.*) (.*) (.*) (.*)$/;
$low = $1;
$freq = $2;
$pos = $3;
if($random > $low) { 
$pos = $pos + int(($random - $low)/$freq) ;
}
print $random," ",$WRDS{$pos},"\n";
}
}
close(FREQ);
close(IN);
dbmclose(WRDS);
